/***************************************************************************
 *  WotK public release                                                    *
 *  (c)2000 'Queen Serenity' and 'Tamas D'Varde (Ryan Pessa)'              *
 *  Be sure to read WotK.doc in the docs directory.                        *
 *  Have fun! :)                                                           *
 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h"  
#include "wwolf.h"


void do_moons(CHAR_DATA *ch, char *argument)
{
int cost = 0;
char arg1[MAX_INPUT_LENGTH];
char buf[MAX_STRING_LENGTH];
argument = one_argument(argument, arg1);
if (!IS_CLASS(ch, CLASS_WWOLF)) {send_to_char("Huh?", ch);return;}
if (arg1[0] == '\0') {
sprintf(buf, "#c
The powers of the moon y'all shall see when you get these moons to one,
two, three.

#y-(#P%d#y) #GNeptus            #y-(#P%d#y) #GUkasu           #y-(#P%d#y) #GArrigo
#C  *Shining Frenzy        *Moonwalk            *Unnatural Speed
  *Sphere of moonlight   *Rage of the Skies   *Lightning Speed
  *Truesight             *Vanish              *Supreme Intuition

#n", ch->pcdata->powers[MOON_POWER_NEPTUS],
ch->pcdata->powers[MOON_POWER_UKASU],
ch->pcdata->powers[MOON_POWER_ARRIGO]);
send_to_char(buf, ch);
if (ch->pcdata->powers[MOON_POWER_ARRIGO] > 2 && ch->pcdata->powers[MOON_POWER_NEPTUS] > 2
 && ch->pcdata->powers[MOON_POWER_UKASU] > 2) {
sprintf(buf, "#c
#y-(#P%d#y) #GChakra            #y-(#P%d#y) #GGtschar          #y-(#P%d#y) #GSpizzy
#C  *Calm                  *Swirling Storm         *Shift
  *Lunar Blessings       *Blackhole              *Flaming Mantis
  *Reckless Abandon      *Unearthly Sacrifice    *Shadowplane

#n", ch->pcdata->powers[MOON_POWER_CHAKRA],
ch->pcdata->powers[MOON_POWER_GTSCHAR],
ch->pcdata->powers[MOON_POWER_SPIZZY]);
send_to_char(buf, ch);
return;
}}
if (ch->pcdata->powers[MOON_POWER_ARRIGO] > 2 && ch->pcdata->powers[MOON_POWER_NEPTUS] > 2
 && ch->pcdata->powers[MOON_POWER_UKASU] > 2) {
if (!str_cmp(arg1, "chakra")) {
   if (ch->pcdata->powers[MOON_POWER_CHAKRA] == 0) cost = 1000000;
   if (ch->pcdata->powers[MOON_POWER_CHAKRA] == 1) cost = 1500000;
   if (ch->pcdata->powers[MOON_POWER_CHAKRA] == 2) cost = 3000000;
   if (cost == 0) {
send_to_char("You already have all the sides of the Chakra moon.\n\r", ch);
return;
}
   if (ch->exp < cost) {
sprintf(buf, "You don't have enough exp to sacrifice to the moons.(%d)", cost);
send_to_char(buf, ch);
return;
}
   else {ch->pcdata->powers[MOON_POWER_CHAKRA] += 1;
ch->exp -= cost;
send_to_char("The Chakra moon grants you unbelievable power.\n\r", ch);
}
  }
else if (!str_cmp(arg1, "gtschar")) {
   if (ch->pcdata->powers[MOON_POWER_GTSCHAR] == 0) cost = 1000000;
   if (ch->pcdata->powers[MOON_POWER_GTSCHAR] == 1) cost = 1500000;
   if (ch->pcdata->powers[MOON_POWER_GTSCHAR] == 2) cost = 2500000;
   if (cost == 0) {
send_to_char("You already have all the sides of the Gtschar moon.\n\r", ch);
return;
}
   if (ch->exp < cost) {
sprintf(buf, "You don't have enough exp to sacrifice to the moons.(%d)", cost);
send_to_char(buf, ch);
return;
}
   else {
ch->pcdata->powers[MOON_POWER_GTSCHAR] += 1;
ch->exp -= cost;
send_to_char("The Gtschar moon grants you unbelievable power.\n\r", ch);
}
}
else if (!str_cmp(arg1, "spizzy")) {
   if (ch->pcdata->powers[MOON_POWER_SPIZZY] == 0) cost = 1000000;
   if (ch->pcdata->powers[MOON_POWER_SPIZZY] == 1) cost = 1500000;
   if (ch->pcdata->powers[MOON_POWER_SPIZZY] == 2) cost = 2500000;
   if (cost == 0) {
send_to_char("You already have all the sides of the Spizzy moon.\n\r",
ch);
return;
}
   if (ch->exp < cost) {
sprintf(buf, "You don't have enough exp to sacrifice to the moons.(%d)", cost);
send_to_char(buf, ch);
return;
}
   else {
ch->pcdata->powers[MOON_POWER_SPIZZY] += 1;
ch->exp -= cost;
send_to_char("The Spizzy moon grants you unbelievable power.\n\r", ch);
}
  }}
if (!str_cmp(arg1, "neptus")) {
   if (ch->pcdata->powers[MOON_POWER_NEPTUS] == 0) cost = 500000;
   if (ch->pcdata->powers[MOON_POWER_NEPTUS] == 1) cost = 750000;
   if (ch->pcdata->powers[MOON_POWER_NEPTUS] == 2) cost = 1000000;
   if (cost == 0) {
send_to_char("You already have all the sides of the Neptus moon.\n\r", ch);
return;
}
   if (ch->exp < cost) {
sprintf(buf, "You don't have enough exp to sacrifice to the moons.(%d)", cost);
send_to_char(buf, ch);
return;
}
   else {ch->pcdata->powers[MOON_POWER_NEPTUS] += 1;
ch->exp -= cost;
send_to_char("The Neptus moon grants you unbelievable power.\n\r", ch);
}
  }
else if (!str_cmp(arg1, "ukasu")) {
   if (ch->pcdata->powers[MOON_POWER_UKASU] == 0) cost = 500000;
   if (ch->pcdata->powers[MOON_POWER_UKASU] == 1) cost = 750000;
   if (ch->pcdata->powers[MOON_POWER_UKASU] == 2) cost = 1000000;
   if (cost == 0) {
send_to_char("You already have all the sides of the ukasu moon.\n\r", ch);
return;
}
   if (ch->exp < cost) {
sprintf(buf, "You don't have enough exp to sacrifice to the moons.(%d)", cost);
send_to_char(buf, ch);
return;
}
   else {
ch->pcdata->powers[MOON_POWER_UKASU] += 1;
ch->exp -= cost;
send_to_char("The ukasu moon grants you unbelievable power.\n\r", ch);
}
}
else if (!str_cmp(arg1, "arrigo")) {
   if (ch->pcdata->powers[MOON_POWER_ARRIGO] == 0) cost = 500000;
   if (ch->pcdata->powers[MOON_POWER_ARRIGO] == 1) cost = 750000;
   if (ch->pcdata->powers[MOON_POWER_ARRIGO] == 2) cost = 1000000;
   if (cost == 0) {
send_to_char("You already have all the sides of the Arrigo moon.\n\r",
ch);
return;
}
   if (ch->exp < cost) {
sprintf(buf, "You don't have enough exp to sacrifice to the moons.(%d)", cost);
send_to_char(buf, ch);
return;
}
   else {
ch->pcdata->powers[MOON_POWER_ARRIGO] += 1;
ch->exp -= cost;
send_to_char("The Arrigo moon grants you unbelievable power.\n\r", ch);
  }
}
return;
}

void do_callupon(CHAR_DATA *ch, char *argument)
{
 if (IS_CLASS(ch, CLASS_WWOLF)) {
  if IS_SET(ch->pcdata->wwaffect, AFF_FRENZYTIMER) {if (ch->exp < 150000)
{send_to_char("You do not have enough exp to sacrifice to neptus.",
ch);return;}
	REMOVE_BIT(ch->pcdata->wwaffect, AFF_FRENZYTIMER);
	send_to_char("The great moon neptus has reimbursed your power",
ch);ch->exp -= 150000;return;
	}
  else {send_to_char("You already have your frenzy timer free.",
ch);return;}}else send_to_char("You are not a Lycantrope!", ch);}


void do_skies(CHAR_DATA *ch, char *argument)
{
char buf[MAX_INPUT_LENGTH];
OBJ_DATA *obj;
 if (!IS_CLASS(ch, CLASS_WWOLF)) {
	send_to_char("You do not have the power of the moons on your
side.\n\r", ch);
	return;
	}
 if (ch->pcdata->powers[MOON_POWER_UKASU] < 2) {
	send_to_char("The great moon Ukasu doesn't feel like your good
enough for that.\n\r", ch);
	return;
	}
if (ch->pcdata->stats[UNI_RAGE] >250) {
send_to_char("To call upon the moon so often would just be being greedy!\n\r",
ch);return;}
    if ((obj = get_eq_char(ch,WEAR_WIELD)) != NULL && obj->value[3] != 0)
    {
        act("$p drops from your right hand.",ch,obj,NULL,TO_CHAR);
        act("$p drops from $n's right hand.",ch,obj,NULL,TO_ROOM);
        obj_from_char(obj);
        obj_to_char(obj, ch);
    }
    if ((obj = get_eq_char(ch,WEAR_HOLD)) != NULL && obj->value[3] != 0)
    {
        act("$p drops from your left hand.",ch,obj,NULL,TO_CHAR);
        act("$p drops from $n's left hand.",ch,obj,NULL,TO_ROOM);
        obj_from_char(obj);
        obj_to_char(obj, ch);
      }
    SET_BIT(ch->affected_by, AFF_POLYMORPH);
    SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_DISGUISED);
    sprintf(buf,"%s the huge snarling beast",ch->name);
    free_string(ch->morph);
    ch->morph = str_dup(buf);
    ch->pcdata->stats[UNI_RAGE] += number_range(50, 150);
    ch->pcdata->stats[UNI_RAGE] += 150;
    if (ch->pcdata->powers[WPOWER_WOLF] > 3) ch->pcdata->stats[UNI_RAGE]
+= 100;
    if (ch->pcdata->stats[UNI_RAGE] > 300)
        ch->pcdata->stats[UNI_RAGE] = 300;      
send_to_char("You raise your voice to the skies and demand the power of Ukasu.\n\r", ch);
return;
}

void do_wlfcalm(CHAR_DATA *ch, char *argument)
{
 if (!IS_CLASS(ch, CLASS_WWOLF)) {
        send_to_char("You do not have the power of the moons on your side.\n\r", ch);
	return;
	}
 if (ch->pcdata->powers[MOON_POWER_UKASU] < 2) {
        send_to_char("The great moon Ukasu doesn't feel like your good enough for that.\n\r", ch);
	return;
	}
if (ch->pcdata->stats[UNI_RAGE] <= 0) {
send_to_char("You can't remove the blessings of Ukasu if you have none !\n\r",
ch);return;}
    ch->pcdata->stats[UNI_RAGE] = 0;
    ch->pcdata->stats[UNI_RAGE] = 0;
send_to_char("You remove the blessings of Ukasu.\n\r", ch);
return;
}


void do_swirlingstorm( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim = ch->fighting;
    ROOM_INDEX_DATA *pRoomIndex;
    char buf[MAX_INPUT_LENGTH];
    int to_room;
    if (!IS_CLASS(ch, CLASS_WWOLF)) {
        send_to_char("You do not have the power of the moons on your side.\n\r", ch);
        return;}     
    if (ch->pcdata->powers[MOON_POWER_UKASU] < 1) {
        send_to_char("You do not have the power of Ukasu on your side.\n\r", ch);
        return;}     
    if ((ch->fighting == NULL)) {
         send_to_char("You are not fighting anyone!\n\r", ch);
         return;
         }
    if ((ch->fighting != victim)) {
        send_to_char("bug", ch);
        return;}
    for ( ; ; )
    {
        to_room = number_range( 0, 65535 );
        pRoomIndex = get_room_index( to_room );
        if ( pRoomIndex != NULL )
        if ( !IS_SET(pRoomIndex->room_flags, ROOM_SOLITARY)
        &&   !IS_SET(pRoomIndex->room_flags, ROOM_NO_TELEPORT)
        &&   to_room != 30008 && to_room != 30002 )
            break; 
    }
    act( "#1$n stirs up a swirling sand storm, and he leaves with $N.#n",
ch, NULL, victim, TO_NOTVICT);
    char_from_room( victim );
    char_to_room( victim, pRoomIndex );
    char_from_room(ch);
    char_to_room( ch, pRoomIndex);
    act( "#1A swirling storm appears and drops our $n and $N.", ch, NULL,
victim, TO_NOTVICT);       
    do_summon( ch, "off");
sprintf(buf, "#1A swirling sand storm appears, grabs you and %s, and take you away.\n\r", victim->name);
send_to_char(buf, ch);
sprintf(buf, "#1A swirling sand storm appears, grabs you and %s, and take you away\n\r.", ch->name);
send_to_char(buf, victim);
    do_summon( victim, "off");
    do_look( victim, "auto" );
    return;
}               

void do_shiningfrenzy(CHAR_DATA *ch, char *argument)
{
  if (!IS_CLASS(ch, CLASS_WWOLF)) {
	send_to_char("You do not have the power of the moons on your side.\n\r", ch);
   	return;}
else if (ch->pcdata->powers[MOON_POWER_NEPTUS] > 0) {
        if (IS_SET(ch->pcdata->wwaffect, AFF_SHININGFRENZY)) {
                send_to_char("Your shining frenzy dies out.\n\r", ch);
                ch->damroll -= 150;
                ch->hitroll -= 150;
                REMOVE_BIT(ch->pcdata->wwaffect, AFF_SHININGFRENZY);
                return; }
        else {
		send_to_char("You spin your body in screaming rage.\n\r", ch);
		act("$n spins his body in screaming rage!", ch, NULL, NULL, TO_ROOM);
                ch->damroll += 150;
		ch->hitroll += 150;
		SET_BIT(ch->pcdata->wwaffect, AFF_SHININGFRENZY);
if (!IS_SET(ch->pcdata->wwaffect, AFF_FRENZYTIMER)) {      
		SET_BIT(ch->pcdata->wwaffect, AFF_FREEBERSERK);
		do_berserk(ch, "");
		SET_BIT(ch->pcdata->wwaffect, AFF_FREEBERSERK);
		do_berserk(ch, "");
		SET_BIT(ch->pcdata->wwaffect, AFF_FREEBERSERK);
		do_berserk(ch, "");
} 
                SET_BIT(ch->pcdata->wwaffect, AFF_FRENZYTIMER);
		return;
		}
}
send_to_char("The great moon neptus has not granted you the power of
shining frenzy.", ch);
return;

}

// by KickAssCoder Devik
//Still bugfixed by Drizzt
void do_blackhole(CHAR_DATA *ch, char *argument)
{
    ROOM_INDEX_DATA *pRoom;
    ROOM_INDEX_DATA *pDir;
    OBJ_DATA *pObj;
    CHAR_DATA *pChar;
CHAR_DATA *bugcheck;    
int i,a,b;

    if ( !IS_CLASS(ch, CLASS_WWOLF)  &&
ch->pcdata->powers[MOON_POWER_GTSCHAR] <3)
    {
        send_to_char("You are not a lycanthrope.\n\r",ch);
	return;
    }

    pRoom = ch->in_room;

    for ( i = 0; i <= 5; i++ )
    {
	char buf[MAX_STRING_LENGTH];
	if ( !pRoom->exit[i] || !pRoom->exit[i]->to_room )
	    continue;
	pDir = pRoom->exit[i]->to_room;
	if ( IS_SET(pDir->room_flags,ROOM_SAFE) )
	    continue;
	for ( pObj = pDir->contents; pObj; pObj = pDir->contents )
	{
a++;
if (a>=5)
continue;	  
  obj_from_room(pObj);
	    obj_to_room(pObj,pRoom);
	    if ( pDir->people )
	    {
		sprintf(buf,"$p is sucked to the %s.",dir_name[rev_dir[i]]);
		act(buf,pDir->people,pObj,NULL,TO_CHAR);
		act(buf,pDir->people,pObj,NULL,TO_ROOM);
	    }
	    sprintf(buf,"$p is sucked in from the %s.",dir_name[i]);
	    act(buf,ch,pObj,NULL,TO_CHAR);
	    act(buf,ch,pObj,NULL,TO_ROOM);
	}
	for ( pChar = pDir->people; pChar; pChar = pDir->people )
	{
a++;
if (a>=5)
continue;
for (bugcheck=pRoom->people;bugcheck->next_in_room!=NULL;bugcheck=bugcheck->next_in_room,b++)
if (b>=15)
{ stc("The room is to crowded.\r\n",ch); return; }
   sprintf(buf,"$n is sucked to the %s.",dir_name[rev_dir[i]]);
	    act(buf,pChar,NULL,NULL,TO_ROOM);
	    sprintf(buf,"You are sucked to the %s.",dir_name[rev_dir[i]]);
	    send_to_char(buf,pChar);
	    char_from_room(pChar);
	    char_to_room(pChar,pRoom);
	    sprintf(buf,"$N is sucked in from the %s.",dir_name[i]);
	    act(buf,ch,NULL,pChar,TO_CHAR);
	    act(buf,ch,NULL,pChar,TO_ROOM);
	}
    }
    WAIT_STATE(ch, 16);
}
void do_lycage(CHAR_DATA *ch, char *argument)
{
  int i = 0,cost = 0;
  char buf[MAX_STRING_LENGTH];
  buf[0] = '\0';
  if (ch->pcdata->drowfavor == 1)
  {
    send_to_char("You can't do this under the moons blessing.\r\n",ch);
    return;
  } else if (ch->pcdata->rank >= 20) {
  send_to_char("Sorry, to high.\n\r",ch);
  return;
  } else{
  if (ch->pcdata->rank == 0)
    i = 1000000;
  if (ch->pcdata->rank >= 1)
    i = 1500000;
  if (ch->pcdata->rank >= 5)
    i = 2000000;
  if (ch->pcdata->rank >= 10)
    i = 3000000;
  if (ch->pcdata->rank >= 15)
    i = 3500000;
  if (i < 500) {
    send_to_char("Error, Please report.\r\n",ch);
    return;
  }
  cost = i;
  cost *= (ch->pcdata->rank+1);
  if (ch->exp <= (cost-1))
   {
     sprintf(buf,"That would cost %d experience points.\r\n",cost);
     send_to_char(buf,ch);
     return;
   } else {
    ch->exp -= cost;
    ch->pcdata->rank += 1;
    send_to_char("You feel your powers improve as you grow older.\r\n",ch);
    return;
   }
  }
}
void do_lycpray(CHAR_DATA *ch, char *argument)
{
  char arg [MAX_INPUT_LENGTH];
  argument = one_argument(argument, arg);
  if ((ch->pcdata->rank > 20)) {
    send_to_char("Sorry, no cheaters here.",ch);
    return;
  } else if (ch->pcdata->drowfavor == 1) {
     send_to_char("You relax your state of concentration.\r\n",ch);
     ch->damroll -= (ch->pcdata->rank * 50);
     ch->hitroll -= (ch->pcdata->rank * 50);
     ch->pcdata->drowfavor = 0;
     return;
   } else {
    send_to_char("You howl at the moon, focusing all your energy on it.\r\n",ch);
    send_to_char("You are blessed by the moon!\r\n",ch);
    act("$n howls at the moon.",ch,NULL,NULL,TO_ROOM);
    ch->damroll += (ch->pcdata->rank * 50);
    ch->hitroll += (ch->pcdata->rank * 50);
    ch->pcdata->drowfavor = 1;
    return;
  }
}

void do_wwlfvanish( CHAR_DATA *ch, char *argument )
{
    if (IS_NPC(ch)) return;
	
        if (!IS_CLASS(ch, CLASS_WWOLF) )
	{
		send_to_char("Huh?\n\r", ch);
		return;
	}
	
        if (IS_CLASS(ch, CLASS_WWOLF) && (ch->pcdata->powers[MOON_POWER_ARRIGO] <= 2))
	{
          send_to_char("Ukasu has not granted you the gift to vanish.\n\r", ch);
	  return;
	}
        if ((IS_CLASS(ch,CLASS_WWOLF)) && (ch->move < 500)) {
         send_to_char("You don't have enough movement to do that",ch);
         return;
        }

    if ( IS_SET(ch->act, PLR_WIZINVIS) )
    {
	REMOVE_BIT(ch->act, PLR_WIZINVIS);
        send_to_char( "You fade into existance.\n\r", ch );
        act( "$n fades into existances.", ch, NULL, NULL, TO_ROOM );
    }
    else
    {   

        send_to_char( "You call upon the power of the moon to make you invisible.\n\r", ch );
        act( "$n vanishes from sight.", ch, NULL, NULL, TO_ROOM );
	SET_BIT(ch->act, PLR_WIZINVIS);
	ch->move -= 500; 
    }
    return;
}
