#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h"


void do_drill( CHAR_DATA *ch, char *argument )
{
    char arg1[MAX_INPUT_LENGTH];
    char arg2[MAX_INPUT_LENGTH];
    char buf[MAX_STRING_LENGTH];

    argument = one_argument( argument, arg1 );
    argument = one_argument( argument, arg2 );

    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_AMAZON))

    {
        do_rand_typo(ch,"");
	return;
    }

    if (arg1[0] == '\0' && arg2[0] == '\0')
    {
	sprintf(buf,"#GDrills Learned#0 (#7%d#0/#710#0)#n\n\r", ch->pcdata->powers[PAMAZON]);
           send_to_char(buf,ch);
	   send_to_char("#0Learned Powers#7:#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] < 1 )
	   send_to_char("#0You know no#G D#grill#G P#gowers#0.#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 1 )
	   send_to_char("#GC#gognizance#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 2 )
	   send_to_char("#GA#gmazShield#0/#GS#genseAura#0/#GJ#gungleLocate#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 3 )
	   send_to_char("#GA#gmazonCamo#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 4 )
	   send_to_char("#GS#geduce#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 5 )
	   send_to_char("#GN#get#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 6 )
	   send_to_char("#GB#garkskin#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 7 )
	   send_to_char("#GF#glare#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 8 )
	   send_to_char("#GS#gteelfist#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 9 )
	   send_to_char("#GE#gnhanced#G S#gpeed#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 10 )
	   send_to_char("#GE#gnhanced#G D#gefense#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 11 )
	   send_to_char("#0You know all the#G D#grill#G P#gowers#0.#n\n\r", ch);
	   send_to_char("\n\r",ch);
	 send_to_char("#GA#gmazon#G R#gituals#7:#n\n\r",ch);
	 sprintf(buf,"#RFire#0 (#7%d#0/#78#0)#o Earth#0 (#7%d#0/#78#0)#L Water#0 (#7%d#0/#78#0)#y Lightning#0 (#7%d#0/#711#0)#C Spirit#0 (#7%d#0/#79#0)#7 P#nh#0y#ns#7i#nc#0a#nl#0 (#7%d#0/#710#0)#7 A#nr#7t#ni#7f#ni#7c#ny#0 (#7%d#0/#716#0)#n\n\r",
	   ch->pcdata->powers[AMA_FIRE], ch->pcdata->powers[AMA_EARTH], ch->pcdata->powers[AMA_WATER], ch->pcdata->powers[AMA_LIGHTNING], ch->pcdata->powers[AMA_SPIRIT], ch->pcdata->powers[AMA_PHYSICAL], ch->pcdata->powers[AMA_ARTIFICY]);
	   send_to_char(buf,ch);
	return;
    }
    if (arg2[0] == '\0')
    {
	if (!str_cmp(arg1,"power") || !str_cmp(arg1,"powers"))
	{
	  sprintf(buf,"#GDrills Learned#0 (#7%d#0/#710#0)#n\n\r", ch->pcdata->powers[PAMAZON]);
	   send_to_char(buf,ch);
          if ( ch->pcdata->powers[PAMAZON] < 1 )
	   send_to_char("#0You know no#G D#grill#G P#gowers#0.#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 1 )
	   send_to_char("#GC#gognizance#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 2 )
	   send_to_char("#GA#gmazShield#0/#GS#genseAura#0/#GJ#gungleLocate#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 3 )
	   send_to_char("#GA#gmazonCamo#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 4 )
	   send_to_char("#GS#geduce#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 5 )
	   send_to_char("#GN#get#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 6 )
	   send_to_char("#GB#garkskin#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 7 )
	   send_to_char("#GF#glare#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 8 )
	   send_to_char("#GS#gteelfist#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 9 )
	   send_to_char("#GE#gnhanced#G S#gpeed#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 10 )
	   send_to_char("#GE#gnhanced#G D#gefence#n\n\r", ch);
	  if ( ch->pcdata->powers[PAMAZON] >= 11 )
	   send_to_char("#0You know all the#G D#grill#G P#gowers#0.#n\n\r", ch);
	  return;
	}
	if (!str_cmp(arg1,"ritual") || !str_cmp(arg1,"rituals"))
	{
	  send_to_char("#GA#gmazon#G R#gituals#7:\n\r",ch);
	  sprintf(buf,"#RFire#0 (#7%d#0/#78#0)#o Earth#0 (#7%d#0/#78#0)#L Water#0 (#7%d#0/#78#0)#y Lightning#0 (#7%d#0/#711#0)#C Spirit#0 (#7%d#0/#79#0)#7 P#nh#0y#ns#7i#nc#0a#nl#0 (#7%d#0/#710#0)#7 A#nr#7t#ni#7f#ni#7c#ny#0 (#7%d#0/#716#0)#n\n\r",
	  ch->pcdata->powers[AMA_FIRE], ch->pcdata->powers[AMA_EARTH], ch->pcdata->powers[AMA_WATER], ch->pcdata->powers[AMA_LIGHTNING], ch->pcdata->powers[AMA_SPIRIT], ch->pcdata->powers[AMA_PHYSICAL], ch->pcdata->powers[AMA_ARTIFICY]);
	  send_to_char(buf,ch);
	return;
	}
	else
	{
	send_to_char("#RSyntax#7: #RD#rrill #0<#GP#gower#0/#GR#gitual#0> <#GI#gmprove#0/#RF#rire#0/#yE#oarth#0/#LW#later#0/#yL#oi#yg#oh#yt#on#yi#on#yg#0/#CS#cpirit#0/#7P#0h#7y#0s#7i#0c#7a#0l#0/#7A#nr#7t#ni#7f#ni#7c#ny#0>#n\n\r",ch);
	return;
	}
    }
    if (!str_cmp(arg2,"improve") && (!str_cmp(arg1,"power") || !str_cmp(arg1,"powers")))
    {
	int improve;
	int cost;
	int max;

	improve = PAMAZON;   
	max=10;
	
	cost = (ch->pcdata->powers[improve]+1) * 50;
	arg1[0] = UPPER(arg1[0]);
	if ( ch->pcdata->powers[improve] >= max )
	{
	    sprintf(buf,"You have already gained all the known powers.\n\r");
	    send_to_char(buf,ch);
	    return;
	}

	if ( cost > ch->practice )
	{
	    sprintf(buf,"#0You need#R %d#0 more primal to advance to power level#R %d#0.#n\n\r", cost - ch->practice, ch->pcdata->powers[PAMAZON] + 1);
	    send_to_char(buf,ch);
	    return;
	}

	if ( ch->practice >= cost )
	{	
	ch->pcdata->powers[improve] += 1;
	ch->practice -= cost;
	sprintf(buf,"#0You learn a new#R Power#0, number#R %d#0.#n\n\r", ch->pcdata->powers[improve]);
	send_to_char(buf,ch);
	}
	return;
    }
    if (!str_cmp(arg2,"fire") && (!str_cmp(arg1,"ritual") || !str_cmp(arg1,"rituals")))
    {
      int improve;
      int cost;
      int max;

      improve = AMA_FIRE;
      max = 8;

      cost = (((ch->pcdata->powers[improve]+1) * 50) + 100);
      arg1[0] = UPPER(arg1[0]);
      if ( ch->pcdata->powers[improve] >= max)
      {
        sprintf(buf,"You have already gained all the#R Fire#n rituals.\n\r");
	send_to_char(buf,ch);
	return;
      }

      if ( cost > ch->practice)
      {
	sprintf(buf,"#0You need#R %d#0 more primal to advance to#R F#rire#0 ritual level#R %d#0.#n\n\r", cost - ch->practice, ch->pcdata->powers[AMA_FIRE] + 1);
	send_to_char(buf,ch);
	return;
      }

      if (ch->practice >= cost)
      {
	ch->pcdata->powers[improve] += 1;
	ch->practice -= cost;
	sprintf(buf,"#0You perform#R F#rire#0 ritual number#R %d#0 to your god Artemis.#n\n\r", ch->pcdata->powers[improve]);
	send_to_char(buf,ch);
	return;
      }
    }
    if (!str_cmp(arg2,"earth") && (!str_cmp(arg1,"ritual") || !str_cmp(arg1,"rituals")))
    {
      int improve;
      int cost;
      int max;

      improve = AMA_EARTH;
      max = 8;

      cost = (((ch->pcdata->powers[improve]+1) * 50) + 100);
      arg1[0] = UPPER(arg1[0]);
      if ( ch->pcdata->powers[improve] >= max)
      {
        sprintf(buf,"You have already gained all the#R Earth#n rituals.\n\r");
        send_to_char(buf,ch);
        return;
      }

      if ( cost > ch->practice)
      {
        sprintf(buf,"#0You need#R %d#0 more primal to advance to#y E#oarth#0 ritual level#R %d#0.#n\n\r", cost - ch->practice, ch->pcdata->powers[improve] + 1);
        send_to_char(buf,ch);
        return;
      }

      if (ch->practice >= cost)
      {
        ch->pcdata->powers[improve] += 1;
        ch->practice -= cost;
        sprintf(buf,"#0You perform#y E#oarth#0 ritual number#R %d#0 to your god Artemis.#n\n\r", ch->pcdata->powers[improve]);
        send_to_char(buf,ch);
        return;
      }
    }
    if (!str_cmp(arg2,"water") && (!str_cmp(arg1,"ritual") || !str_cmp(arg1,"rituals")))
    {
      int improve;
      int cost;
      int max;

      improve = AMA_WATER;
      max = 8;

      cost = (((ch->pcdata->powers[improve]+1) * 50) + 100);
      arg1[0] = UPPER(arg1[0]);
      if ( ch->pcdata->powers[improve] >= max)
      {
        sprintf(buf,"You have already gained all the#L W#later#n rituals.\n\r");
        send_to_char(buf,ch);
        return;
      }

      if ( cost > ch->practice)
      {
        sprintf(buf,"#0You need#R %d#0 more primal to advance to#L W#later#0 ritual level#R %d#0.#n\n\r", cost - ch->practice, ch->pcdata->powers[improve] + 1);
        send_to_char(buf,ch);
        return;
      }

      if (ch->practice >= cost)
      {
        ch->pcdata->powers[improve] += 1;
        ch->practice -= cost;
        sprintf(buf,"#0You perform#L W#later#0 ritual number#R %d#0 to your god Artemis.#n\n\r", ch->pcdata->powers[improve]);
        send_to_char(buf,ch);
        return;
      }
    }
    if ((!str_cmp(arg2,"lightning") || !str_cmp(arg2,"air")) && (!str_cmp(arg1,"ritual") || !str_cmp(arg1,"rituals")))
    {
      int improve;
      int cost;
      int max;

      improve = AMA_LIGHTNING;
      max = 11;

      cost = (((ch->pcdata->powers[improve]+1) * 50) + 100);
      arg1[0] = UPPER(arg1[0]);
      if ( ch->pcdata->powers[improve] >= max)
      {
        sprintf(buf,"You have already gained all the#o L#yi#og#yh#ot#yn#oi#yn#og rituals.\n\r");
        send_to_char(buf,ch);
        return;
      }

      if ( cost > ch->practice)
      {
        sprintf(buf,"#0You need#R %d#0 more primal to advance to#y L#oi#yg#oh#yt#on#yi#on#yg#0 ritual level#R %d#0.#n\n\r", cost - ch->practice, ch->pcdata->powers[improve] + 1);
        send_to_char(buf,ch);
        return;
      }

      if (ch->practice >= cost)
      {
        ch->pcdata->powers[improve] += 1;
        ch->practice -= cost;
        sprintf(buf,"#0You perform#y L#oi#yg#oh#yt#on#yi#on#yg#0 ritual number#R %d#0 to your god Artemis.#n\n\r", ch->pcdata->powers[improve]);
        send_to_char(buf,ch);
        return;
      }
    }
    if (!str_cmp(arg2,"spirit") && (!str_cmp(arg1,"ritual") || !str_cmp(arg1,"rituals")))
    {
      int improve;
      int cost;
      int max;

      improve = AMA_SPIRIT;
      max = 9;

      cost = (((ch->pcdata->powers[improve]+1) * 50) + 300);
      arg1[0] = UPPER(arg1[0]);
      if ( ch->pcdata->powers[improve] >= max)
      {
        sprintf(buf,"You have already gained all the#C S#cpirit#n rituals.\n\r");
        send_to_char(buf,ch);
        return;
      }

      if ( cost > ch->practice)
      {
        sprintf(buf,"#0You need#R %d#0 more primal to advance to#C S#cpirit#0 ritual level#R %d#0.#n\n\r", cost - ch->practice, ch->pcdata->powers[improve] + 1);
        send_to_char(buf,ch);
        return;
      }

      if (ch->practice >= cost)
      {
        ch->pcdata->powers[improve] += 1;
        ch->practice -= cost;
        sprintf(buf,"#0You perform#C S#cpirit#0 ritual number#R %d#0 to your god Artemis.#n\n\r", ch->pcdata->powers[improve]);
        send_to_char(buf,ch);
        return;
      }
    }
    if (!str_cmp(arg2,"physical") && (!str_cmp(arg1,"ritual") || !str_cmp(arg1,"rituals")))
    {
      int improve;
      int cost;
      int max;

      improve = AMA_PHYSICAL;
      max = 10;

      cost = (((ch->pcdata->powers[improve]+1) * 50) + 100);
      arg1[0] = UPPER(arg1[0]);
      if ( ch->pcdata->powers[improve] >= max)
      {
        sprintf(buf,"You have already gained all the#7 P#nh#0y#ns#7i#nc#0a#nl#n rituals.\n\r");
        send_to_char(buf,ch);
        return;
      }

      if ( cost > ch->practice)
      {
        sprintf(buf,"#0You need#R %d#0 more primal to advance to#7 P#nh#0y#ns#7i#nc#0a#nl#0 ritual level#R %d#0.#n\n\r", cost - ch->practice, ch->pcdata->powers[improve] + 1);
        send_to_char(buf,ch);
        return;
      }

      if (ch->practice >= cost)
      {
        ch->pcdata->powers[improve] += 1;
        ch->practice -= cost;
        sprintf(buf,"#0You perform#7 P#nh#0y#ns#7i#nc#0a#nl#0 ritual number#R %d#0 to your god Artemis.#n\n\r", ch->pcdata->powers[improve]);
        send_to_char(buf,ch);
        return;
      }
    }
    if (!str_cmp(arg2,"artificy") && (!str_cmp(arg1,"ritual") || !str_cmp(arg1,"rituals")))
    {
      int improve;
      int cost;
      int max;

      improve = AMA_ARTIFICY;
      max = 16;

      cost = (((ch->pcdata->powers[improve]+1) * 25) + 50);
      arg1[0] = UPPER(arg1[0]);
      if ( ch->pcdata->powers[improve] >= max)
      {
        sprintf(buf,"You have already gained all the#7 A#nr#7t#ni#7f#ni#7c#ny#n rituals.\n\r");
        send_to_char(buf,ch);
        return;
      }

      if ( cost > ch->practice)
      {
        sprintf(buf,"#0You need#R %d#0 more primal to advance to#7 A#nr#7t#ni#7f#ni#7c#ny#0 ritual level#R %d#0.#n\n\r", cost - ch->practice, ch->pcdata->powers[improve] + 1);
        send_to_char(buf,ch);
        return;
      }

      if (ch->practice >= cost)
      {
        ch->pcdata->powers[improve] += 1;
        ch->practice -= cost;
        sprintf(buf,"#0You perform#7 A#nr#7t#ni#7f#ni#7c#ny#0 ritual number#R %d#0 to your god Artemis.#n\n\r", ch->pcdata->powers[improve]);
        send_to_char(buf,ch);
        return;
      }
    }
    else
    {
      stc("#RSyntax#7:#R D#rrill#0 <#GP#gower#0/#GR#gitual#0> <#GI#gmprove#0/#RF#rire#0/#yE#oarth#0/#LW#later#0/#yL#oi#yg#oh#yt#on#yi#on#yg#0/#CS#cpirit#0/#7P#nh#0y#ns#7i#nc#0a#nl#0/#7A#nr#7t#ni#7f#ni#7c#ny#0>#n\n\r",ch);
      return;
    }
}

void do_amazons( CHAR_DATA *ch, char *argument )
{

	 char buf[MAX_STRING_LENGTH];
	 char arg[MAX_INPUT_LENGTH];
	 CHAR_DATA *gch;

	 one_argument( argument, arg );

	 if (IS_NPC(ch)) return;
	 if (!IS_CLASS(ch, CLASS_AMAZON) )
	 {
         do_rand_typo(ch,"");
         return;
	 }

	 send_to_char("#GA#gmazon#G W#garriors#0:#n\n\r",ch);
	 send_to_char("#0[#G     Name#0     ] [#G Gen#0 ] [#G Hits#g   %#0 ] [#G Mana#g   %#0 ] [#G Move#g   %#0 ] [#G    Exp#0     ]#n\n\r", ch );

	 for ( gch = char_list; gch != NULL; gch = gch->next )
	 {
	 if ( IS_NPC(gch) ) continue;
	 if ( !IS_CLASS(gch, CLASS_AMAZON) ) continue;
	 {
		 sprintf( buf,
		 "#0[#G%-14s#0] [#G  %d#0  ] [#G%-6d#g %3d#0] [#G%-6d#g %3d#0] [#G%-6d#g %3d#0] [#G%-12d#0]#n\n\r",

		capitalize( gch->name ),
		gch->generation,
		gch->hit,  (gch->hit  * 100 / gch->max_hit ),
		gch->mana, (gch->mana * 100 / gch->max_mana),
		gch->move, (gch->move * 100 / gch->max_move),
                gch->exp);
		send_to_char( buf, ch );
	 }
	 }
	 return;
}

void do_animalsenses( CHAR_DATA *ch, char *argument )
{
      if (IS_NPC(ch)) return;
      if (!IS_CLASS(ch, CLASS_AMAZON) )
      {
        do_rand_typo(ch,"");
        return;
      }

      if  (ch->pcdata->powers[AMA_PHYSICAL] < 2 )
      {
	send_to_char("You have not learned the animal senses drill.\n\r", ch);
	return;
      }
      if ( IS_SET(ch->act, PLR_HOLYLIGHT) )
      {
	REMOVE_BIT(ch->act, PLR_HOLYLIGHT);
	send_to_char( "The enhanced animal senses leave you.\n\r", ch );
	return;
      }
      else
      {
	SET_BIT(ch->act, PLR_HOLYLIGHT);
	send_to_char( "The jungle animals' senses enhance your own.\n\r", ch );
	return;
      }
      return;
}

void do_amazoncamo( CHAR_DATA *ch, char *argument)
{

    if ( IS_NPC(ch) )
     return;

    if (!IS_CLASS(ch, CLASS_AMAZON))
    {
	  do_rand_typo(ch,"");
	  return;
    }

    if (ch->pcdata->powers[PAMAZON] < 3)
    {
	send_to_char("You have not learned the AmazonCamo Drill.\n\r", ch);
	return;
    }

    if ( IS_SET(ch->act, PLR_WIZINVIS) )
    {
	REMOVE_BIT(ch->act, PLR_WIZINVIS);
	send_to_char( "You stop camouflaging yourself.\n\r", ch );
	act("$n slowly emerges into sight.",ch,NULL,NULL,TO_ROOM);
    }
    else
    {
	if (has_timer(ch)) return;

	send_to_char( "You amazoncamo yourself.\n\r", ch );
	act("$n slowly fades into the background.",ch,NULL,NULL,TO_ROOM);
	SET_BIT(ch->act, PLR_WIZINVIS);
    }
    return;
}

void do_net(CHAR_DATA *ch,char *argument)
{
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch,CLASS_AMAZON))
  {
  do_rand_typo(ch,"");
  return;
  }
  if  (ch->pcdata->powers[AMA_PHYSICAL] < 4 )
    {
	send_to_char("You have not performed the fourth Physical ritual, weaving.\n\r",ch);
	return;
    }
  if (!IS_SET(ch->newbits, NEW_JAWLOCK))
  {
  send_to_char("You ready a net to throw over your enemy.\n\r",ch);
  SET_BIT(ch->newbits, NEW_JAWLOCK);
  return;
  }
  else if (IS_SET(ch->newbits, NEW_JAWLOCK))
  { 
  send_to_char("You stow away your net.\n\r",ch);
  REMOVE_BIT(ch->newbits,NEW_JAWLOCK);
  return;
  }
return;
}

void do_barkskin( CHAR_DATA *ch, char *argument )

{
    if ( IS_NPC(ch) )
    return;

    if (!IS_CLASS(ch, CLASS_AMAZON) )
	{
        check_social(ch,"bark",argument);
  	return;
	}
	 if  (ch->pcdata->powers[AMA_EARTH] < 4 )
	{
	send_to_char("You have not learned the Barkskin Drill.\n\r",ch);
	return;
	}

    if ( IS_SET(ch->pcdata->powers[AMA_POWER], AMA_BARKSKIN) )
    {
	send_to_char( "Your skin loses its bark-like properties.\n\r", ch );
        ch->armor += 1500;
	ch->hitroll -= 250;
	ch->damroll -= 250;
	REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_BARKSKIN);
	return;
    }

    else if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_BARKSKIN))
    {
	send_to_char( "Your skin hardens like bark.\n\r", ch );
        ch->armor -= 1500;
	ch->hitroll += 250;
	ch->damroll += 250;
	SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_BARKSKIN);
	return;
    }
    return;
}

void do_genesis( CHAR_DATA *ch, char *argument )
{
    OBJ_INDEX_DATA *pObjIndex;
    OBJ_DATA *obj;
    char arg[MAX_INPUT_LENGTH];
    int vnum = 0;

    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_AMAZON))
    {
	    do_rand_typo(ch,"");
	    return;
    }

   if (arg[0] == '\0')
    {
	send_to_char("Please specify what kind of equipment you want to create.\n\r", ch );
	send_to_char("Mask, Bracer, Lorica, Gloves, Cape, Boots or Spear.\n\r", ch );
	return;
    }
    if      (!str_cmp(arg,"mask"     )) vnum = 27943;   
    else if (!str_cmp(arg,"bracer"   )) vnum = 27944;
    else if (!str_cmp(arg,"lorica"   )) vnum = 27945;
    else if (!str_cmp(arg,"gloves"   )) vnum = 27946;
    else if (!str_cmp(arg,"cape"     )) vnum = 27947;
    else if (!str_cmp(arg,"boots"    )) vnum = 27948;
    else if (!str_cmp(arg,"spear"    )) vnum = 27949;
    else
    {
	send_to_char("Invalid argument, read the list again!\n\r", ch );
	return;
    }
    if (ch->practice < 140)
    {
	send_to_char("#0It costs#R 140#0 primal to create a piece of Amazon equipment.#n\n\r",ch);
	return;
    }
   
    if ( vnum == 0 || (pObjIndex = get_obj_index( vnum )) == NULL)
    {
	send_to_char("Missing object, please inform an SG Admin.\n\r",ch);
	return;
    }
    ch->practice -= 140;
    obj = create_object(pObjIndex, 50);
    obj->questowner = str_dup(ch->pcdata->switchname);
    obj_to_char(obj, ch);
    act("$p appears in your hands!",ch,obj,NULL,TO_CHAR);
    act("$p appears in $n's hands!",ch,obj,NULL,TO_ROOM);
    return;
}

void do_lavafists( CHAR_DATA *ch, char *argument)
{
    if ( IS_NPC(ch) )
    return;

    if (!IS_CLASS(ch, CLASS_AMAZON))
    {
      do_rand_typo(ch,"");
      return;
    }
    if (ch->pcdata->powers[AMA_FIRE] < 1)
    {
	  send_to_char("You have not learned the lavafists#R F#rire#n ritual.\n\r",ch);
	  return;
    }

    if (IS_SET(ch->pcdata->powers[AMA_POWER], AMA_LAVA_FIST))
    {
	  REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_LAVA_FIST);
        send_to_char("The lava drips off of your fists.\n\r",ch);
	  act("The lava drips off of $n's fists.\n\r",ch,NULL,NULL,TO_ROOM);
	  return;
    }
    if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_LAVA_FIST))
    {
	  SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_LAVA_FIST);
	  send_to_char("You bite your lip as your fists become engulfed in lava!\n\r",ch);
	  act("$n's fists turn into lava!\n\r",ch,NULL,NULL,TO_ROOM);
	  return;
    }
}

void do_slavetravel( CHAR_DATA *ch, char *argument)
{
	 CHAR_DATA *victim;
	 char buf[MAX_STRING_LENGTH];
	 char arg[MAX_INPUT_LENGTH];
	 argument = one_argument(argument, arg);

	 if ( IS_NPC(ch) )
	return;

	 if (!IS_CLASS(ch, CLASS_AMAZON))
	{
	do_rand_typo(ch,"");
	return;
	}
	if  (ch->pcdata->powers[AMA_EARTH] < 4 )
	{
	  send_to_char("You have not learned the earth ritual slavetravel.\n\r", ch);
	  return;
	}
	if (ch->move < 2000)
	{
	send_to_char("Slavetravel requires 2000 movement points.\n\r",ch);
	return;
	}
	if (ch->fight_timer > 0)
	{
	  send_to_char("You may not slavetravel with a fight timer.\n\r", ch);
	  return;
	}
	if ( arg[0] == '\0' )
	{
	send_to_char( "Slavetravel to whom?\n\r", ch );
	return;
	}

	if ( ( victim = get_char_world( ch, arg ) ) == NULL )
	{
	send_to_char( "They aren't here.\n\r", ch );
	return;
	}
	if (ch == victim)
	{
	send_to_char("But you're already at yourself!\n\r",ch);
	return;
	}
	if (victim->in_room->vnum == ch->in_room->vnum)
	{
	send_to_char("But you're already there!\n\r",ch);
	return;
	}
	if ( victim->move > ch->move )
	{
	send_to_char("You are not allowed to travel to them.\n\r", ch);
	return;
	}
	if ((ch->in_room->vnum >= 50) && (ch->in_room->vnum <= 68))
	{
		send_to_char("You cannot do this while you are in the arena.\n\r", ch);
		return;
	}
	if ((victim->in_room->vnum >= 50) && (victim->in_room->vnum <= 68))
	{
	  send_to_char("You cannot do this while they are in the arena.\n\r", ch);
	  return;
	}

	 char_from_room(ch);
	 char_to_room(ch,victim->in_room);

	 if (IS_NPC(victim))

	{
	sprintf(buf,"You call upon a slave to take you to %s!\n\r",victim->short_descr);
	send_to_char(buf, ch);
	}

	 if (!IS_NPC(victim))
	{
	sprintf(buf,"You call upon a slave to take you to %s!\n\r",victim->name);
	send_to_char(buf, ch);
	WAIT_STATE(ch, 6);
	}
	 act("$n walks into the room, being led by their slave!\n\r",ch,NULL,NULL,TO_ROOM);
	 do_look(ch, "auto");
	 ch->move = ch->move - 2000;
	 return;
}

void do_aworship( CHAR_DATA *ch, char *argument )
 {
    int sn;
    int level;
    int spelltype;

    if ( IS_NPC(ch)) return;

        if (!IS_CLASS(ch, CLASS_AMAZON))
        {
        do_rand_typo(ch,"");
        return;
        }

        if (ch->mana < 500)
        {
        send_to_char("You don't have enough mana.\n\r", ch );
        return;
       }

    if ( ( sn = skill_lookup( "aworship" ) ) < 0 ) return;
    spelltype = skill_table[sn].target;
    level = 500;
    (*skill_table[sn].spell_fun) ( sn, 205, ch, ch );
    WAIT_STATE( ch, 12 );
    ch->mana = ch->mana - 500;
    return;
}

void do_flameblast( CHAR_DATA *ch, char *argument )
{
	char arg[MAX_INPUT_LENGTH];
	char buf[MAX_STRING_LENGTH];
	CHAR_DATA *victim;
	int dam;

	argument = one_argument(argument, arg);

	if (IS_NPC(ch))
	return;
	if (!IS_CLASS(ch, CLASS_AMAZON))
	{
          do_rand_typo(ch,"");
	  return;
	}
	if (ch->mana < (7500 / (ch->pcdata->powers[AMA_FIRE] / 2)))
	{
	  sprintf(buf,"You need#R %d#n mana to use flameblast!\n\r", (7500 / (ch->pcdata->powers[AMA_FIRE] / 2)));
	  send_to_char(buf, ch);
	  return;
	}
	if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_LAVA_FIST))
	{
	  send_to_char("You must have lavafists on to use flameblast.\n\r",ch);
	  return;
	}
	if ((IS_CLASS(ch, CLASS_AMAZON) && (ch->pcdata->powers[AMA_FIRE] < 4)))
	{
	  send_to_char("You need 4 in the#R F#rire#n ritual to use flameblast.\n\r",ch);
	  return;
	}
	if ((victim = get_char_room(ch,arg)) == NULL)
	{
	  stc("They are not here.\n\r",ch);
	  return;
	}
	if ((ch->position == POS_SLEEPING) || ch->position == POS_RESTING || ch->position == POS_DEAD || ch->position == POS_MORTAL || ch->position == POS_INCAP || ch->position == POS_STUNNED || ch->position == POS_MEDITATING || ch->position == POS_SITTING)
	{
	  send_to_char("You must be fighting or standing!\n\r",ch);
	  return;
	}
        else
	{
	  dam = (victim->max_hit * .05) + (ch->pcdata->powers[AMA_FIRE] * 100);
	  dam += number_range(-500,+500);

	  sprintf(buf,"#RYou call upon Artemis to blast flame onto $N.#C [#7%d#C]#n\n\r",dam);
	  act(buf,ch,NULL,victim,TO_CHAR);
	  sprintf(buf,"#G$n#R calls upon Artemis to blast you with flame.#C [#7%d#C]#n\n\r",dam);
	  sprintf(buf,"#G$n#R calls upon Artemis to blast#G $n#R with flame.#C [#7%d#C]#n\n\r",dam);
	  act(buf,ch,NULL,victim,TO_NOTVICT);
	  if (number_range(1,4) == 2) SET_BIT(victim->affected_by, AFF_FLAMING);
	  if ((ch->fighting) == NULL) set_fighting(ch, victim);
	  victim->hit -= dam;
	  ch->mana -= (7500 / (ch->pcdata->powers[AMA_FIRE] / 2));
	  WAIT_STATE(ch, dam / 500);
	  return;
	}
	return;
}

void do_firefaith( CHAR_DATA *ch, char *argument )
{
	if ( IS_NPC(ch) )
	return;

	if (!IS_CLASS(ch, CLASS_AMAZON) )
	{
	  do_rand_typo(ch,"");
	  return;
	}
	  if  (ch->pcdata->powers[AMA_FIRE] < 6 )
	{
	send_to_char("You do not know the#R F#rire#n ritual fire faith.\n\r",ch);
	return;
	}

    if (IS_SET(ch->pcdata->powers[AMA_POWER], AMA_FIRE_FAITH) )
    {
	send_to_char( "Your will releases the fiery faith of Artemis.\n\r", ch );
	ch->hitroll -= 500;
	ch->damroll -= 500;
	REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_FIRE_FAITH);
	return;
    }

    else if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_FIRE_FAITH))
    {
	send_to_char( "Your will brings about the fiery faith of Artemis.\n\r", ch );
	ch->hitroll += 500;
	ch->damroll += 500;
	SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_FIRE_FAITH);
	return;
    }
}

void do_firewill( CHAR_DATA *ch, char *argument )
{
	if (IS_NPC(ch))
	return;

	if (!IS_CLASS(ch, CLASS_AMAZON))
	{
	  do_rand_typo(ch,"");
	  return;
	}
	  if  (ch->pcdata->powers[AMA_FIRE] < 7 )
	{
	send_to_char("You do not know the#R F#rire#n ritual will of fire.\n\r",ch);
	return;
	}

    if (IS_SET(ch->pcdata->powers[AMA_POWER], AMA_FIRE_WILL) )
    {
	send_to_char( "Your will is less aggressive.\n\r", ch );
	REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_FIRE_WILL);
	return;
    }

    else if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_FIRE_WILL))
    {
	send_to_char( "Your will has the aggression of Artemis.\n\r", ch );
	SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_FIRE_WILL);
	return;
    }
}


void do_srampage( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  OBJ_DATA *obj;
  char arg[MAX_INPUT_LENGTH];
  char buf1[MAX_STRING_LENGTH];
  char buf2[MAX_STRING_LENGTH];
  char buf3[MAX_STRING_LENGTH];
  int dam;
  int fspear;
  int espear;
  int ispear;
  int lspear;
  int sspear;
  int pspear;
  int count = 0;
  if (ch->pcdata->powers[AMA_FIRE]      >= 3) count += 1;
  if (ch->pcdata->powers[AMA_EARTH]     >= 6) count += 1;
  if (ch->pcdata->powers[AMA_WATER]     >= 4) count += 1;
  if (ch->pcdata->powers[AMA_LIGHTNING] >= 5) count += 1;
  if (ch->pcdata->powers[AMA_SPIRIT]    >= 6) count += 1;
  if (ch->pcdata->powers[AMA_PHYSICAL]  >= 8) count += 1;

  argument = one_argument(argument, arg);

  fspear = (ch->pcdata->powers[AMA_FIRE]      >= 3);
  espear = (ch->pcdata->powers[AMA_EARTH]     >= 6);
  ispear = (ch->pcdata->powers[AMA_WATER]     >= 4);
  lspear = (ch->pcdata->powers[AMA_LIGHTNING] >= 5);
  sspear = (ch->pcdata->powers[AMA_SPIRIT]    >= 6);
  pspear = (ch->pcdata->powers[AMA_PHYSICAL]  >= 8);

  if (IS_NPC(ch)) return;

  if (!IS_CLASS(ch, CLASS_AMAZON))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (ch->pcdata->powers[AMA_LIGHTNING] < 11)
  {
    send_to_char("You need level 11 lightning to use spear rampage.\n\r",ch);
    return;
  }
  if (((obj = get_eq_char(ch, WEAR_WIELD)) != NULL && obj->pIndexData->vnum != 27949) || (obj = get_eq_char(ch, WEAR_WIELD)) == NULL)
  {
    send_to_char("You must be wielding an amazon spear!\n\r",ch);
    return;
  }
  if (arg[0] == '\0')
  {
    send_to_char("Spear rampage on whom?\n\r",ch);
    return;
  }
  if ((victim = get_char_room(ch,arg)) == NULL)
  {
    send_to_char("They are not in this room!\n\r",ch);
    return;
  }
  if ((((victim = get_char_room(ch,arg)) != NULL) && (ch->position < POS_RESTING)))
  {
    send_to_char("You must be fighting or standing!\n\r",ch);
    return;
  }
  if (is_safe(victim, ch))
  {
    send_to_char("You or they are set with a safe flag.\n\r",ch);
    return;
  }
  else
  {
   if (ch->move < 5000) return;
   if ((ch->fighting) == NULL) set_fighting(ch, victim);
   dam = number_range(2500,3500);
   dam += char_damroll(ch);
   dam = cap_dam(ch,victim,dam);
   if (( fspear ) && ch->move >= 5000)
    sprintf(buf1,"#R$n's#R f#rire#R s#rpear#0 strikes#R $N#0 [#7%d#0]#n", dam);
    sprintf(buf2,"#RYour#R f#rire#R s#rpear#0 strikes#R $N#0 [#7%d#0]#n", dam);
    sprintf(buf3,"#R$n's#R f#rire#R s#rpear#0 strikes#R you#0 [#7%d#0]#n", dam);
    act(buf1,ch,NULL,victim, TO_NOTVICT);
    act(buf2,ch,NULL,victim, TO_CHAR);
    act(buf3,ch,NULL,victim, TO_VICT);
    hurt_person(ch, victim, dam);
    ch->move -= 5000;
    if (victim->position == POS_DEAD || ch->in_room != victim->in_room) return;
   dam = number_range(2500,3500);
   dam += char_damroll(ch);
   dam = cap_dam(ch,victim,dam);
   if (ch->move < 5000) return;
   if (( espear ) && ch->move >= 5000)
    sprintf(buf1,"#R$n's#y e#oarthen#y s#opear#0 strikes#R $N#0 [#7%d#0]#n", dam);
    sprintf(buf2,"#RYour#y e#oarthen#y s#opear#0 strikes#R $N#0 [#7%d#0]#n", dam);
    sprintf(buf3,"#R$n's#y e#oarthen#y s#opear#0 strikes#R you#0 [#7%d#0]#n", dam);
    act(buf1,ch,NULL,victim, TO_NOTVICT);
    act(buf2,ch,NULL,victim, TO_CHAR);
    act(buf3,ch,NULL,victim, TO_VICT);
    hurt_person(ch, victim, dam);
    ch->move -= 5000;
    if (victim->position == POS_DEAD || ch->in_room != victim->in_room) return;
   dam = number_range(2500,3500);
   dam += char_damroll(ch);
   dam = cap_dam(ch,victim,dam);
   if (ch->move < 5000) return;
   if (( ispear ) && ch->move >= 5000)
    sprintf(buf1,"#R$n's#C i#Lce#C s#Lpear#0 strikes#R $N#0 [#7%d#0]#n", dam);
    sprintf(buf2,"#RYour#C i#Lce#C s#Lpear#0 strikes#R $N#0 [#7%d#0]#n", dam);
    sprintf(buf3,"#R$n's#C i#Lce#C s#Lpear#0 strikes#R you#0 [#7%d#0]#n", dam);
    act(buf1,ch,NULL,victim, TO_NOTVICT);
    act(buf2,ch,NULL,victim, TO_CHAR);
    act(buf3,ch,NULL,victim, TO_VICT);
    hurt_person(ch, victim, dam);
    ch->move -= 5000;
    if (victim->position == POS_DEAD || ch->in_room != victim->in_room) return;
   dam = number_range(2500,3500);
   dam += char_damroll(ch);
   dam = cap_dam(ch,victim,dam);
   if (ch->move < 5000) return;
   if (( lspear ) && ch->move >= 5000)
    sprintf(buf1,"#R$n's#y l#oi#yg#oh#yt#on#yi#on#yg#o s#yp#oe#ya#or#0 strikes#R $N#0 [#7%d#0]#n", dam);
    sprintf(buf2,"#RYour#y l#oi#yg#oh#yt#on#yi#on#yg#o s#yp#oe#ya#or#0 strikes#R $N#0 [#7%d#0]#n", dam);
    sprintf(buf3,"#R$n's#y l#oi#yg#oh#yt#on#yi#on#yg#o s#yp#oe#ya#or#0 strikes#R you#0 [#7%d#0]#n", dam);
    act(buf1,ch,NULL,victim, TO_NOTVICT);
    act(buf2,ch,NULL,victim, TO_CHAR);
    act(buf3,ch,NULL,victim, TO_VICT);
    hurt_person(ch, victim, dam);
    ch->move -= 5000;
    if (victim->position == POS_DEAD || ch->in_room != victim->in_room) return;
   dam = number_range(2500,3500);
   dam += char_damroll(ch);
   dam = cap_dam(ch,victim,dam);
   if (ch->move < 5000) return;
   if (( sspear ) && ch->move >= 5000)
    sprintf(buf1,"#R$n's#C s#cpiritual#C s#cpear#0 strikes#R $N#0 [#7%d#0]#n", dam);
    sprintf(buf2,"#RYour#C s#cpiritual#C s#cpear#0 strikes#R $N#0 [#7%d#0]#n", dam);
    sprintf(buf3,"#R$n's#C s#cpiritual#C s#cpear#0 strikes#R you#0 [#7%d#0]#n", dam);
    act(buf1,ch,NULL,victim, TO_NOTVICT);
    act(buf2,ch,NULL,victim, TO_CHAR);
    act(buf3,ch,NULL,victim, TO_VICT);
    hurt_person(ch, victim, dam);
    ch->move -= 5000;
    if (victim->position == POS_DEAD || ch->in_room != victim->in_room) return;
   dam = number_range(2500,3500);
   dam += char_damroll(ch);
   dam = cap_dam(ch,victim,dam);
   if (ch->move < 5000) return;
   if (( pspear ) && ch->move >= 5000)
    sprintf(buf1,"#R$n's#G p#goisonous#G s#gpear#0 strikes#R $N#0 [#7%d#0]#n", dam);
    sprintf(buf2,"#RYour#G p#goisonous#G s#gpear#0 strikes#R $N#0 [#7%d#0]#n", dam);
    sprintf(buf3,"#R$n's#G p#goisonous#G s#gpear#0 strikes#R you#0 [#7%d#0]#n", dam);
    act(buf1,ch,NULL,victim, TO_NOTVICT);
    act(buf2,ch,NULL,victim, TO_CHAR);
    act(buf3,ch,NULL,victim, TO_VICT);
    hurt_person(ch, victim, dam);
    if (number_range(1,4) == 2) 
    {
      if (ch->tick_timer[TIMER_AMA_POISON] == 0)
      {
        SET_BIT(victim->newbits2, NEW2_AMA_POISON);
        SET_TIMER(victim, TIMER_AMA_POISON, 6);
        act("$n is poisoned by $N's spear.",victim,NULL,ch,TO_NOTVICT);
        act("You are poisoned by $N's spear.",victim,NULL,ch,TO_CHAR);
        act("You poison $n with your spear.",victim,NULL,ch,TO_VICT);
        return;
      }
      if (ch->tick_timer[TIMER_AMA_POISON] != 0)
      {
        ADD_TIMER(ch, TIMER_AMA_POISON, 1);
        act("$n's suffering worsens as $N's spear poisons $m again.",victim,NULL,ch,TO_ROOM);
        act("Your suffering worsens as $N's spear poisons you again.",victim,NULL,ch,TO_CHAR);
        act("$n's suffering worsens as your spear poisons $m again.",victim,NULL,ch,TO_VICT);
        return;
      }
      return;
    }
    if (victim->position == POS_DEAD || ch->in_room != victim->in_room) return;
    ch->move -= 5000;
  }
}  
void do_artemisform( CHAR_DATA *ch, char *argument )
{
  char buf[MAX_STRING_LENGTH];

  if (IS_NPC(ch))
  return;

  if (!IS_CLASS(ch, CLASS_AMAZON))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (ch->pcdata->powers[AMA_SPIRIT] < 7)
  {
    send_to_char("You need level 8 spirit to use avatar of artemis.\n\r",ch);
    return;
  }
  if (ch->position != POS_STANDING)
  {
    send_to_char("You must be standing!\n\r",ch);
    return;
  }
  if (IS_SET(ch->pcdata->powers[AMA_POWER], AMA_ARTEMIS_FORM))
  {
    send_to_char("You transform back into a mortal entity.\n\r",ch);
    act("$n returns to being a mortal entity.",ch,NULL,NULL,TO_ROOM);
    (REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_ARTEMIS_FORM));
    (REMOVE_BIT(ch->affected_by, AFF_POLYMORPH));
    free_string(ch->morph);
    ch->morph = str_dup( "" );
    ch->hitroll -= 750;
    ch->damroll -= 750;
    ch->armor += 2000;
    return;
  }
  if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_ARTEMIS_FORM))
  {
    send_to_char("You undergo an extreme transformation and return as an Avatar of Artemis.\n\r",ch);
    act("$n changes into an Avatar of Artemis.",ch,NULL,NULL,TO_ROOM);
    sprintf(buf,"%s the Avatar of Artemis",ch->name);
    free_string(ch->morph);
    ch->morph = str_dup(buf);
    (SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_ARTEMIS_FORM));
    (SET_BIT(ch->affected_by, AFF_POLYMORPH));
    ch->hitroll += 750;
    ch->damroll += 750;
    ch->armor	-= 2000;
    return;
  }
}

void do_eartharmor( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch))
  return;

  if (!IS_NPC(ch) && !IS_CLASS(ch, CLASS_AMAZON))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (ch->pcdata->powers[AMA_EARTH] < 1 )
  {
    send_to_char("You do not posses the 1st earth ritual.\n\r",ch);
    return;
  }
  if (ch->mana < 2000 || ch->move < 2000)
  {
    send_to_char("You need 2000 mana and movement.\n\r",ch);
    return;
  }
  if (ch->position != POS_STANDING)
  {
    send_to_char("You must be standing to activate earth armor!\n\r",ch);
    return;
  }
  if (IS_SET(ch->pcdata->powers[AMA_POWER], AMA_EARTH_ARMOR))
  {
    send_to_char("Your armor softens as the earth enchanting it dissolves.\n\r",ch);
    act("$n's armor softens as the earth enchanting it dissolves.",ch,NULL,NULL,TO_ROOM);
    (REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_EARTH_ARMOR));
    ch->armor	+= 1500;
  }
  else if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_EARTH_ARMOR))
  {
    send_to_char("Your armor hardens as you enchant it with ancient earthen magic.\n\r",ch);
    act("$n's armor hardens as they enchant it with ancient earthen magic.",ch,NULL,NULL,TO_ROOM);
    (SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_EARTH_ARMOR));
    ch->armor	-= 1500;
  }
}

void do_junglebless( CHAR_DATA *ch, char *argument )
{
  int sn;
  int spelltype;

  if (IS_NPC(ch)) return;

  if (!IS_NPC(ch) && !IS_CLASS(ch, CLASS_AMAZON))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (IS_CLASS(ch, CLASS_AMAZON) && ch->pcdata->powers[AMA_EARTH] < 3 )
  {
    send_to_char("You do not posses the 3rd earth rituial.\n\r",ch);
    return;
  }
  if (ch->mana < 2500)
  {
    send_to_char("You need 2500 mana to use junglebless.\n\r",ch);
    return;
  }
  if ( ( sn = skill_lookup( "junglebless" ) ) < 0 ) return;
  spelltype = skill_table[sn].target;
  (*skill_table[sn].spell_fun) ( sn, 205, ch, ch );
  WAIT_STATE( ch, 12);
  ch->mana -= 2500;
  return;
}

/*
 void do_vambush( CHAR_DATA *ch, CHAR_DATA *victim, char *argument )
{
}
 */
void do_icyaura( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch))
  return;

  if (!IS_NPC(ch) && !IS_CLASS(ch, CLASS_AMAZON))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (ch->pcdata->powers[AMA_WATER] < 6)
  {
    send_to_char("You do not have the 6th water ritual.\n\r",ch);
    return;
  }
  if (ch->position != POS_STANDING)
  {
    send_to_char("You must be standing to activate your icy aura!\n\r",ch);
    return;
  }
  if (IS_SET(ch->pcdata->powers[AMA_POWER], AMA_ICY_AURA))
  {
    send_to_char("Your aura relaxes and warms.\n\r",ch);
    act("The air around $n seems to warm.",ch,NULL,NULL,TO_ROOM);
    (REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_ICY_AURA));
  }
  else if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_ICY_AURA))
  {
    send_to_char("Your aura becomes icy and ready to strike at attackers.\n\r",ch);
    act("The air around $n seems to chill.",ch,NULL,NULL,TO_ROOM);
    (SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_ICY_AURA));
  }
}

void do_ashield( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch))
  return;

  if (!IS_NPC(ch) && !IS_CLASS(ch, CLASS_AMAZON))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (ch->pcdata->powers[AMA_EARTH] < 7)
  {
    send_to_char("You do not have the 7th earth ritual.\n\r",ch);
    return;
  }
  if (ch->position != POS_STANDING)
  {
    send_to_char("You must be standing to call upon Artemis to shield you!\n\r",ch);
    return;
  }
  if (IS_SET(ch->pcdata->powers[AMA_POWER], AMA_ASHIELD))
  {
    send_to_char("Artemis stops shielding your mortal body.\n\r",ch);
    act("You notice a bright flash of light shimmer and vanish from around $n's body.",ch,NULL,NULL,TO_ROOM);
    (REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_ASHIELD));
    (REMOVE_BIT(ch->immune, IMM_SHIELDED));
    ch->armor += 500;
  }
  else if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_ASHIELD))
  {
    send_to_char("Artemis begins to shield your pathetic mortal body.\n\r",ch);
    act("You notice a bright flash of light which is quickly absorbed by $n's body.",ch,NULL,NULL,TO_ROOM);
    (SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_ASHIELD));
    (SET_BIT(ch->immune, IMM_SHIELDED));
    ch->armor -= 500;
  }
}

void do_icearmor( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch))
  return;

  if (!IS_NPC(ch) && !IS_CLASS(ch, CLASS_AMAZON))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (ch->pcdata->powers[AMA_WATER] < 5)
  {
    send_to_char("You do not have the 5th water ritual.\n\r",ch);
    return;
  }
  if (ch->position != POS_STANDING)
  {
    send_to_char("You must be standing to activate your icy aura!\n\r",ch);
    return;
  }
  if (IS_SET(ch->pcdata->powers[AMA_POWER], AMA_ICE_ARMOR))
  {
    send_to_char("Your frozen armor melts away.\n\r",ch);
    act("The frozen armor $n is wearing melts away.",ch,NULL,NULL,TO_ROOM);
    (REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_ICE_ARMOR));
  }
  else if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_ICE_ARMOR))
  {
    send_to_char("A mystical suit of frozen armor surrounds you.\n\r",ch);
    act("A mystical suit of frozen armor surrounds $n.",ch,NULL,NULL,TO_ROOM);
    (SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_ICE_ARMOR));
  }
}

void do_pinset( CHAR_DATA *ch, char *argument )
{
  char buf[MAX_STRING_LENGTH];
  char arg[MAX_INPUT_LENGTH];
  int ritfire = ch->pcdata->powers[AMA_FIRE];
  int ritearth = ch->pcdata->powers[AMA_EARTH];
  int ritwater = ch->pcdata->powers[AMA_WATER];
  int ritlightning = ch->pcdata->powers[AMA_LIGHTNING];
  int ritspirit = ch->pcdata->powers[AMA_SPIRIT];
  int ritphysical = ch->pcdata->powers[AMA_PHYSICAL];
  int ritartificy = ch->pcdata->powers[AMA_ARTIFICY];

  argument = one_argument( argument, arg );

  if (IS_NPC(ch))
  return;

  if (!IS_NPC(ch) && !IS_CLASS(ch, CLASS_AMAZON))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (ch->pcdata->powers[AMA_LIGHTNING] < 9)
  {
    send_to_char("You do not have the 9th lightning ritual.\n\r",ch);
    return;
  }
  if (ch->position != POS_STANDING)
  {
    send_to_char("You must be standing to set your arrow type!\n\r",ch);
    return;
  }
  if (arg[0] == '\0')
  {
      stc("#CA#cvailable#C A#crrow#C T#cypes#0:#n\n\r",ch);
    if ((ritfire) > 1)
    {
      sprintf(buf,"#RF#rlaming#0%s\r", ritfire > 7 || ritearth > 4 || ritwater > 2 || ritwater > 6 || ritwater > 7 || ritlightning > 3 
       || ritlightning > 10 || ritspirit > 5 || ritphysical > 7 || ritartificy > 2 || ritartificy > 9 || ritartificy > 10 ? ", " : "");
      stc(buf, ch);
    }
    if ((ritfire) > 7)
    {
      sprintf(buf,"#RE#rxploding#0%s\r", ritearth > 4 || ritwater > 2 || ritwater > 6 || ritwater > 7 || ritlightning > 3
       || ritlightning > 10 || ritspirit > 5 || ritphysical > 7 || ritartificy > 2 || ritartificy > 9 || ritartificy > 10 ? ", " : "");
      stc(buf, ch);
    }
    if ((ritearth) > 4)
    {
      sprintf(buf, "#yS#oerrated#0%s\r", ritwater > 2 || ritwater > 6 || ritwater > 7 || ritlightning > 3
       || ritlightning > 10 || ritspirit > 5 || ritphysical > 7 || ritartificy > 2 || ritartificy > 9 || ritartificy > 10 ? ", " : ".");
      stc(buf, ch);
    }
    if ((ritwater) > 2)
    {
      sprintf(buf, "#LI#lce#0%s\r", ritwater > 6 || ritwater > 7 || ritlightning > 3
       || ritlightning > 10 || ritspirit > 5 || ritphysical > 7 || ritartificy > 2 || ritartificy > 9 || ritartificy > 10 ? ", " : ".");
      stc(buf, ch);
    }
    if ((ritwater) > 6)
    {
      sprintf(buf, "#GA#gcid#0%s\r", ritwater > 7 || ritlightning > 3
       || ritlightning > 10 || ritspirit > 5 || ritphysical > 7 || ritartificy > 2 || ritartificy > 9 || ritartificy > 10 ? ", " : ".");
      stc(buf, ch);
    }
    if ((ritwater) > 7)
    {
      sprintf(buf, "#LF#lreeze#0%s\r", ritlightning > 3
       || ritlightning > 10 || ritspirit > 5 || ritphysical > 7 || ritartificy > 2 || ritartificy > 9 || ritartificy > 10 ? ", " : ".");
      stc(buf, ch);
    }
    if ((ritlightning) > 3)
    {
      sprintf(buf, "#oL#yightning#0%s\r", ritlightning > 10 || ritspirit > 5 || ritphysical > 7 || ritartificy > 2 || ritartificy > 9 || ritartificy > 10 ? ", " : ".");
      stc(buf, ch);
    }
    if ((ritlightning) > 10)
    {
      sprintf(buf, "#oC#yhain#0%s\r", ritspirit > 5 || ritphysical > 7 || ritartificy > 2 || ritartificy > 9 || ritartificy > 10 ? ", " : ".");
      stc(buf, ch);
    }
    if ((ritspirit) > 4)
    {
      sprintf(buf, "#7Spirit#0%s\r", ritphysical > 7 || ritartificy > 2 || ritartificy > 9 || ritartificy > 10 ? ", " : ".");
      stc(buf, ch);
    }
    if ((ritphysical) > 7)
    {
      sprintf(buf, "#0P#7otion#0%s\r", ritartificy > 2 || ritartificy > 9 || ritartificy > 10 ? ", " : ".");
      stc(buf, ch);
    }
    if ((ritartificy) > 2)
    {
      sprintf(buf, "#7B#narbed#0%s\r", ritartificy > 9 || ritartificy > 10 ? ", " : ".");
      stc(buf, ch);
    }
    if ((ritartificy) > 9)
    {
      sprintf(buf, "#7S#nilver#0%s\r", ritartificy > 10 ? ", " : ".");
      stc(buf, ch);
    }
    if ((ritartificy) > 10)
    {
      stc("#sE#slemental#0. \r",ch);
    }
  return;
  }
  if (((ritfire) > 1) && (!str_cmp(arg,"flaming") || !str_cmp(arg,"flame") || !str_cmp(arg,"fire")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_FLAME);
    stc("Your rain of arrows will now be flaming.\n\r",ch);
    return;
  }
  if (((ritfire) > 7) && (!str_cmp(arg,"explode") || !str_cmp(arg,"exploding")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_EXPLODE);
    stc("Your arrows will now explode upon impact!\n\r",ch);
    return;
  }
  if (((ritearth) > 4) && (!str_cmp(arg,"serrate") || !str_cmp(arg,"serrated")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_SERRATE);
    stc("You sharpen your arrows to serrate your victims.\n\r",ch);
    return;
  }
  if (((ritwater) > 2) && (!str_cmp(arg,"ice") || !str_cmp(arg,"icy")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_ICE);
    stc("Your arrows chill and harden into ice.\n\r",ch);
    return;
  }
  if (((ritwater) > 6) && (!str_cmp(arg,"acid") || !str_cmp(arg,"acidic")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_ACID);
    stc("You dip your arrows in a small vial of acid, coating them with it.\n\r",ch);
    return;
  }
  if (((ritwater) > 7) && (!str_cmp(arg,"freeze") || !str_cmp(arg,"freezing")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_FREEZE);
    stc("You freeze your arrows to stop your enemies!\n\r",ch);
    return;
  }
  if (((ritlightning) > 3) && (!str_cmp(arg,"lightning") || !str_cmp(arg,"shock") || !str_cmp(arg,"shocking")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_LIGHTNING);
    stc("Your arrows seem to shimmer with inner power, then suddenly explode, revealing identical arrows, composed of lightning!\n\r",ch);
    return;
  }
  if (((ritlightning) > 10) && (!str_cmp(arg,"chain lightning") || !str_cmp(arg,"chainlightning") || !str_cmp(arg,"chain") || !str_cmp(arg,"chain_lightning")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_CHAIN);
    stc("Your arrows crackle, and seem to multiply as you imbue them with lightning!\n\r",ch);
    return;
  }
  if (((ritspirit) > 5) && (!str_cmp(arg,"spirit") || !str_cmp(arg,"spiritual")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_SPIRIT);
    stc("Your arrows seem to waver in and out of reality as you pour your energy into them.\n\r",ch);
    return;
  }
  if (((ritphysical) > 7) && (!str_cmp(arg,"potion") || !str_cmp(arg,"unknown") || !str_cmp(arg,"potions")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_POTION);
    stc("You coat your arrows with an unknown substance...\n\r",ch);
    return;
  }
  if (((ritartificy) > 2) && (!str_cmp(arg,"barb") || !str_cmp(arg,"barbed")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_BARB);
    stc("You place small thorns on the sides of your arrows, making them more painfull.\n\r",ch);
    return;
  }
  if (((ritartificy) > 9) && (!str_cmp(arg,"silver") || !str_cmp(arg,"mithril")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_SILVER);
    stc("You replace the arrow tips with special ones of silver.\n\r",ch);
    return;
  }
  if (((ritartificy) > 10) && (!str_cmp(arg,"elemental") || !str_cmp(arg,"elem")))
  {
    remove_pinset( ch );
    SET_BIT(ch->pcdata->powers[AMA_PINSET], PIN_ELEMENTAL);
    stc("You imbue your arrows with the power of all elements, may your enemies feel the wrath of all living things!\n\r",ch);
    return;
  }
}

void remove_pinset args(( CHAR_DATA *ch ))
{
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_FLAME) 
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_FLAME);
    stc("Your arrows stop flaming.\n\r",ch);
  }
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_EXPLODE) 
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_EXPLODE);  
  }
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_SERRATE)
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_SERRATE);
  }
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_ICE) 
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_ICE);
  }
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_ACID) 
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_ACID);
  }
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_FREEZE) 
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_FREEZE);
  }
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_LIGHTNING) 
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_LIGHTNING);
  }
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_CHAIN) 
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_CHAIN);
  }
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_SPIRIT) 
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_SPIRIT);
  }
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_POTION) 
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_POTION);
  }
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_BARB) 
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_BARB);
  }
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_SILVER) 
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_SILVER);
  }
  if IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_ELEMENTAL) 
  {
    REMOVE_BIT(ch->pcdata->powers[AMA_PINSET], PIN_ELEMENTAL);
  }
  return;
}

void do_amazonfire( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    char arg1[MAX_INPUT_LENGTH];
    char buf1[MAX_STRING_LENGTH];
    char buf2[MAX_STRING_LENGTH];
    char buf3[MAX_STRING_LENGTH];
    int dam;

    argument = one_argument( argument, arg1 );

    if (IS_NPC(ch)) return;
    if (!IS_CLASS(ch, CLASS_AMAZON))
    {
      do_rand_typo(ch,"");
      return;
    }

    if (ch->pcdata->powers[AMA_LIGHTNING] < 9 )
    {
      send_to_char("You need at least 9 lightning rituals to use pincushion.\n\r",ch);
      return;
    }

    if (arg1[0] == '\0' )
    {
      send_to_char("Pincushion whom?\n\r",ch);
      return;
    }

    if ((victim = get_char_room(ch,arg1)) == NULL)
    {
      send_to_char("They are not here.\n\r",ch);
      return;
    }

    if (is_safe(ch,victim))
    {
      send_to_char("You or your victim are safe.\n\r",ch);
      return;
    }

    if (IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_FLAME))
    {
      dam = ((ch->pcdata->powers[AMA_FIRE] * 500) + number_range(-250, 250));
      stc("This is a test at this time.\n\r",ch);
      sprintf(buf1,"$n's#R fire#n arrows strike $N. [%d]", dam);
      sprintf(buf2,"Your#R fire#n arrows strike $N. [%d]", dam);
      sprintf(buf3,"$n's#R fire#n arrows strike you. [%d]", dam);
      act(buf1,ch,NULL,victim, TO_NOTVICT);
      act(buf2,ch,NULL,victim, TO_CHAR);
      act(buf3,ch,NULL,victim, TO_VICT);
      if (number_range(1,3) != 2) SET_BIT(victim->affected_by, AFF_FLAMING);
      hurt_person(ch, victim, dam);
      WAIT_STATE(ch, dam/750);
      return;
    }
    if (IS_SET(ch->pcdata->powers[AMA_PINSET], PIN_EXPLODE))
    {
      stc("This is a test at this time.\n\r",ch);
      return;
    }
}

void do_awinds( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch))
  return;

  if (!IS_NPC(ch) && !IS_CLASS(ch, CLASS_AMAZON))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (ch->pcdata->powers[AMA_LIGHTNING] < 2)
  {
    send_to_char("You do not have the 2nd lightning ritual.\n\r",ch);
    return;
  }
  if (ch->position != POS_STANDING)
  {
    send_to_char("You must be standing to activate the winds of time!\n\r",ch);
    return;
  }
  if (IS_SET(ch->pcdata->powers[AMA_POWER], AMA_WINDS_TIME))
  {
    send_to_char("The great winds around you slow and stop.\n\r",ch);
    act("The great force surrounding $n seems to vanish.",ch,NULL,NULL,TO_ROOM);
    (REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_WINDS_TIME));
  }
  else if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_WINDS_TIME))
  {
    send_to_char("You laugh as powerful winds speed around you, slowing the world around you.\n\r",ch);
    act("A great force surrounds $n, and $e seems to speed up.",ch,NULL,NULL,TO_ROOM);
    (SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_WINDS_TIME));
  }
}

void do_awrath( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch))
  return;

  if (!IS_NPC(ch) && !IS_CLASS(ch, CLASS_AMAZON))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (ch->pcdata->powers[AMA_LIGHTNING] < 1)
  {
    send_to_char("You do not have the 1st lightning ritual.\n\r",ch);
    return;
  }
  if (ch->position != POS_STANDING)
  {
    send_to_char("You must be standing to activate the wrath of Artemis!\n\r",ch);
    return;
  }
  if (IS_SET(ch->pcdata->powers[AMA_POWER], AMA_ARTEMIS_WRATH))
  {
    send_to_char("The anger of your god fades.\n\r",ch);
    act("The anger of $n's god seems to fade away.",ch,NULL,NULL,TO_ROOM);
    (REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_ARTEMIS_WRATH));
  }
  else if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_ARTEMIS_WRATH))
  {
    send_to_char("You cackle as Artemis surrounds you with her anger.\n\r",ch);
    act("$n cackles as Artemis surrounds $m with her anger.",ch,NULL,NULL,TO_ROOM);
    (SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_ARTEMIS_WRATH));
  }
}

void do_agrace( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch))
  return;

  if (!IS_NPC(ch) && !IS_CLASS(ch, CLASS_AMAZON))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (ch->pcdata->powers[AMA_LIGHTNING] < 3)
  {
    send_to_char("You do not have the 3rd lightning ritual.\n\r",ch);
    return;
  }
  if (ch->position != POS_STANDING)
  {
    send_to_char("You must be standing to activate the grace of Artemis!\n\r",ch);
    return;
  }
  if (IS_SET(ch->pcdata->powers[AMA_POWER], AMA_ARTEMIS_GRACE))
  {
    send_to_char("You feel much more clumsy as your god blessed grace vanishes.\n\r",ch);
    act("$n appears to become $s clumsy old self.",ch,NULL,NULL,TO_ROOM);
    (REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_ARTEMIS_GRACE));
  }
  else if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_ARTEMIS_GRACE))
  {
    send_to_char("You feel much more nimble and quick.\n\r",ch);
    act("$n appears to grow extraordinarily quick and nimble.",ch,NULL,NULL,TO_ROOM);
    (SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_ARTEMIS_GRACE));
  }
}

void do_laura( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch))
  return;

  if (!IS_NPC(ch) && !IS_CLASS(ch, CLASS_AMAZON))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (ch->pcdata->powers[AMA_LIGHTNING] < 6)
  {
    send_to_char("You do not have the 6th lightning ritual.\n\r",ch);
    return;
  }
  if (ch->position != POS_STANDING)
  {
    send_to_char("You must be standing to activate an aura of lightning!\n\r",ch);
    return;
  }
  if (IS_SET(ch->pcdata->powers[AMA_POWER], AMA_LIGHTNING_AURA))
  {
    send_to_char("You feel your skin cool.\n\r",ch);
    act("$n's skin stops giving off heat and light.",ch,NULL,NULL,TO_ROOM);
    (REMOVE_BIT(ch->pcdata->powers[AMA_POWER], AMA_LIGHTNING_AURA));
  }
  else if (!IS_SET(ch->pcdata->powers[AMA_POWER], AMA_LIGHTNING_AURA))
  {
    send_to_char("You notices many sparks being emitted around your body.\n\r",ch);
    act("$n's skin crackles and pops.",ch,NULL,NULL,TO_ROOM);
    (SET_BIT(ch->pcdata->powers[AMA_POWER], AMA_LIGHTNING_AURA));
  }
}
