/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/


#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h"

void do_implant( CHAR_DATA *ch, char *argument )
{
  char arg1[MAX_INPUT_LENGTH];
  char arg2[MAX_INPUT_LENGTH];
  char buf[MAX_STRING_LENGTH];
  char buf2[MAX_STRING_LENGTH];
  argument = one_argument( argument, arg1 );
  argument = one_argument( argument, arg2 );

  if (IS_NPC(ch)) return;

  if (!IS_CLASS(ch, CLASS_CYBORG))
  {
    do_rand_typo(ch,"");
    return;
  }

  if ( arg1[0] == '\0' && arg2[0] == '\0')
  {
    send_to_char("#RI#rmplant#R L#revels#0:\n\r",ch); 
    sprintf(buf, "#CEyes#0: (#7%d#0)#C Body#0: (#7%d#0)#C Legs#0:     (#7%d#0)#C Mouth#0:    (#7%d#0)#C Hands#0: (#7%d#0)#n\n",
    UMIN(ch->pcdata->powers[CYBORG_EYES],5), 
    UMIN(ch->pcdata->powers[CYBORG_BODY],6), 
    UMIN(ch->pcdata->powers[CYBORG_LEGS],6),
    UMIN(ch->pcdata->powers[CYBORG_MOUTH],5),
    UMIN(ch->pcdata->powers[CYBORG_HANDS],5));
    sprintf(buf2,"#CBack#0: (#7%d#0)#C Feet#0: (#7%d#0)#C Hardware#0: (#7%d#0)#C Software#0: (#7%d#0)#n\n\r",
    UMIN(ch->pcdata->powers[CYBORG_BACK],5), 
    UMIN(ch->pcdata->powers[CYBORG_FEET],5),
    UMIN(ch->pcdata->powers[CYBORG_HARDWARE],9),
    UMIN(ch->pcdata->powers[CYBORG_SOFTWARE],9));
    send_to_char(buf,ch);
    send_to_char(buf2,ch);
    return;
  }
  if (arg2[0] == '\0')
  {
    if (!str_cmp(arg1,"eyes"))
    {
     send_to_char("#7Visual Implants#0:#n\n\r",ch);
      if (ch->pcdata->powers[CYBORG_EYES] < 1)
      send_to_char("None.\n\r",ch);
      if (ch->pcdata->powers[CYBORG_EYES] > 0)
      {
        if (ch->pcdata->powers[CYBORG_EYES] > 3)
        {
          send_to_char("Your have bio-mechanical eyes blessed by Lloth.\n\r",ch);
          send_to_char("Your aura is shielded.\n\r",ch);
          send_to_char("Your senses are improved, allowing you to see the stats and location of others.\n\r",ch);
          return;
        }
        else if ((ch->pcdata->powers[CYBORG_EYES] == 2))
        send_to_char("Your can see in the night and shadows.n\r",ch);
        else if ((ch->pcdata->powers[CYBORG_EYES] == 1))
        send_to_char("Your can see in the night.\n\r",ch);
      }
    return;
    }
    else if (!str_cmp(arg1,"legs"))
    {
      send_to_char("#7Leg Implants#0:#n\n\r",ch);
      if (ch->pcdata->powers[CYBORG_LEGS] < 1)
      send_to_char("None.\n\r",ch);
      if (ch->pcdata->powers[CYBORG_LEGS] > 0)
      send_to_char("Your spider legs have been replaced with stronger mechanical ones.\n\r",ch);
      if (ch->pcdata->powers[CYBORG_LEGS] > 1)
      send_to_char("Lloth has blessed you with superior speed.\n\r",ch);
      if (ch->pcdata->powers[CYBORG_LEGS] > 2)
      send_to_char("Your are one of Lloths champions.\n\r",ch);
      if (ch->pcdata->powers[CYBORG_LEGS] > 3)
      send_to_char("You are a true drow warrior, you have supreme fighting skils.\n\r",ch);
      if (ch->pcdata->powers[CYBORG_LEGS] > 4)
      send_to_char("Your spit is now pure poison.\n\r",ch);
      return;
    }
    else if (!str_cmp(arg1,"body"))
    {
      send_to_char("#7Body Implants#0:#n\n\r",ch);
      if (ch->pcdata->powers[CYBORG_BODY] < 1)
      send_to_char("None.\n\r",ch);
      if (ch->pcdata->powers[CYBORG_BODY] > 0)
      send_to_char("Your body's armor has been increased greatly.\n\r",ch);
      if (ch->pcdata->powers[CYBORG_BODY] > 1)
      send_to_char("Your body can absorb certain attacks.\n\r",ch);
      if (ch->pcdata->powers[CYBORG_BODY] > 2)
      send_to_char("You body slam your enemy when you have first attack.\n\r",ch);
      if (ch->pcdata->powers[CYBORG_BODY] > 3)
      send_to_char("You have the power to cloak yourself and become invisible.\n\r",ch);
      if (ch->pcdata->powers[CYBORG_BODY] > 4)
      send_to_char("You have poisoned stingers that shoot at your enemies from your body.\n\r",ch);
      if (ch->pcdata->powers[CYBORG_BODY] > 5)
      send_to_char("You regenerate very fast.\n\r",ch);
      return;
    }
    else if (!str_cmp(arg1,"mouth"))
    {
      send_to_char("#7Mouth Implants#0:#n\n\r",ch);
     if (ch->pcdata->powers[CYBORG_MOUTH] < 1)
      send_to_char("None.\n\r",ch);
     if (ch->pcdata->powers[CYBORG_MOUTH] > 0)
      send_to_char("Upgrade 1.\n\r",ch);
     return;
    }
    else if (!str_cmp(arg1,"hands"))
    {
      send_to_char("#7Hand Implants#0:#n\n\r",ch);
     if (ch->pcdata->powers[CYBORG_HANDS] < 1)
      send_to_char("None.\n\r",ch);
     if (ch->pcdata->powers[CYBORG_HANDS] > 0)
      send_to_char("Enhanced grip.\n\r",ch);
     if (ch->pcdata->powers[CYBORG_HANDS] > 1)
      send_to_char("Unknown.\n\r",ch);
     if (ch->pcdata->powers[CYBORG_HANDS] > 2)
      send_to_char("Unknown.\n\r",ch);
     if (ch->pcdata->powers[CYBORG_HANDS] > 3)
      send_to_char("Tractor beam projectors.\n\r",ch);
     if (ch->pcdata->powers[CYBORG_HANDS] > 4)
      send_to_char("Palm blasters.\n\r",ch);
     return;
    }
    else if (!str_cmp(arg1,"back"))
    {
      send_to_char("#7Back Implants#0:#n\n\r",ch);
     if (ch->pcdata->powers[CYBORG_BACK] < 1)
      send_to_char("None.\n\r",ch);
     if (ch->pcdata->powers[CYBORG_BACK] > 0)
      send_to_char("Unknown.\n\r",ch);
     return;
    }
    else if (!str_cmp(arg1,"feet"))
    {
      send_to_char("#7Feet Implants#0:#n\n\r",ch);
     if (ch->pcdata->powers[CYBORG_FEET] < 1)
      send_to_char("None.\n\r",ch);
     if (ch->pcdata->powers[CYBORG_FEET] > 0)
      send_to_char("Unknown.\n\r",ch);
     return;
    }
    else if (!str_cmp(arg1,"hardware"))
    {
      send_to_char("#7Hardware Modifications#0:#n\n\r",ch);
     if (ch->pcdata->powers[CYBORG_HARDWARE] < 1)
      send_to_char("None.\n\r",ch);
     if (ch->pcdata->powers[CYBORG_HARDWARE] > 0)
      send_to_char("Unknown.\n\r",ch);
     return;
    }
    else if (!str_cmp(arg1,"software"))
    {
      send_to_char("#7Software Upgrades#0:#n\n\r",ch);
     if (ch->pcdata->powers[CYBORG_SOFTWARE] < 1)
      send_to_char("None.\n\r",ch);
     if (ch->pcdata->powers[CYBORG_SOFTWARE] > 0)
      send_to_char("Unknown.\n\r",ch);
     return;
    }
    send_to_char("#RI#rmplant#R L#revels#0:#n\n\r",ch);
    sprintf(buf, "#CEyes#0: (#7%d#0)#C Body#0: (#7%d#0)#C Legs#0:     (#7%d#0)#C Mouth#0:    (#7%d#0)#C Hands#0: (#7%d#0)#n\n",
    UMIN(ch->pcdata->powers[CYBORG_EYES],5),
    UMIN(ch->pcdata->powers[CYBORG_BODY],6),
    UMIN(ch->pcdata->powers[CYBORG_LEGS],5),
    UMIN(ch->pcdata->powers[CYBORG_MOUTH],5),
    UMIN(ch->pcdata->powers[CYBORG_HANDS],5));
    sprintf(buf2,"#CBack#0: (#7%d#0)#C Feet#0: (#7%d#0)#C Hardware#0: (#7%d#0)#C Software#0: (#7%d#0)#n\n\r",
    UMIN(ch->pcdata->powers[CYBORG_BACK],5),
    UMIN(ch->pcdata->powers[CYBORG_FEET],5),
    UMIN(ch->pcdata->powers[CYBORG_HARDWARE],9),
    UMIN(ch->pcdata->powers[CYBORG_SOFTWARE],9));
    send_to_char(buf,ch);
    send_to_char(buf2,ch);
    return;
  }
  if (!str_cmp(arg2,"improve"))
  {
      int implant;
      int cost;
      int max;

      if (!str_cmp(arg1,"eyes" )) {implant = CYBORG_EYES; max = 5;}
      else if (!str_cmp(arg1,"body")) {implant = CYBORG_BODY; max = 6;}
      else if (!str_cmp(arg1,"legs")) {implant = CYBORG_LEGS; max = 5;}
      else if (!str_cmp(arg1,"mouth")) {implant = CYBORG_MOUTH; max = 5;}
      else if (!str_cmp(arg1,"hands")) {implant = CYBORG_HANDS; max = 5;}
      else if (!str_cmp(arg1,"back")) {implant = CYBORG_BACK; max = 5;}
      else if (!str_cmp(arg1,"feet")) {implant = CYBORG_FEET; max = 5;}
      else if (!str_cmp(arg1,"hardware")) {implant = CYBORG_HARDWARE; max = 9;}
      else if (!str_cmp(arg1,"software")) {implant = CYBORG_SOFTWARE; max = 9;}
      else
      {
        send_to_char("#RS#ryntax#0: #nI#7mplant#0 <#CE#cyes#0/#CB#cody#0/#CL#cegs#0/#CM#couth#0/#CH#cands#0/#CB#cack#0/#CF#ceet#0/#CH#cardware#0/#CS#coftware#0> <#7Improve#0>#n\n\r",ch);
        return;
      }
      if ((ch->pcdata->powers[implant] == 1)) cost = 20000;
      else if ((ch->pcdata->powers[implant] == 2)) cost = 40000;
      else if ((ch->pcdata->powers[implant] == 3)) cost = 75000;
      else if ((ch->pcdata->powers[implant] == 4)) cost = 100000;
      else if ((ch->pcdata->powers[implant] == 5)) cost = 250000;
      else if ((ch->pcdata->powers[implant] == 6)) cost = 500000;
      else if ((ch->pcdata->powers[implant] == 7)) cost = 750000;
      else if ((ch->pcdata->powers[implant] >= 8)) cost = 1000000;
	else cost = 12500;
      arg1[0] = UPPER(arg1[0]);
      if ((ch->pcdata->powers[implant] >= max ))
      {
        sprintf(buf,"You already have all implants on your %s.\n\r",arg1);
        send_to_char(buf,ch);
        return;
      }

      if ( cost > ch->pcdata->stats[CLASS_POINTS] )
      {
        sprintf(buf,"#0You need#R %d#0 more cyborg points to add an implant to#R %s.#n\n\r",cost - ch->pcdata->stats[CLASS_POINTS],arg1);
        send_to_char(buf,ch);
        return;
      }

      ch->pcdata->powers[implant] += 1;
      ch->pcdata->stats[CLASS_POINTS] -= cost;
      sprintf(buf,"You add an implant to your %s.\n\r",arg1);
      send_to_char(buf,ch);
      return;
  }
  else send_to_char("#RS#ryntax#0:#n I#7mplant#0 <#CE#cyes#0/#CB#cody#0/#CL#cegs#0/#CM#couth#0/#CH#cands#0/#CB#cack#0/#CF#ceet#0/#CH#cardware#0/#CS#coftware#0 <#nI#7mprove#0>#n\n\r",ch);
  return;
}

void do_stuntubes( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;

    if ( IS_NPC(ch) ) return;
    if ( !IS_CLASS(ch, CLASS_CYBORG) )   
    {
    do_rand_typo(ch,"");
    return;
    }
        
    if (ch->pcdata->powers[CYBORG_BODY] < 5 || ch->pcdata->powers[CYBORG_LEGS] < 5 )
    {
      send_to_char("You need level 5 implants on your legs and body to use this.\n\r",ch);
      return;
    }
        
    if (ch->move < 1000)
    {
	stc("You need 1000 move to do that.\n\r",ch);
	return;
    }

    if ( ( victim = ch->fighting ) == NULL )
    {
        send_to_char( "You aren't fighting anyone.\n\r", ch );
        return;
    }
    WAIT_STATE( ch,     12);
    ch->move -= 1000;

    one_hit(ch,victim,gsn_stuntubes,1);
    one_hit(ch,victim,gsn_stuntubes,1);
    one_hit(ch,victim,gsn_stuntubes,1);
    if (!IS_AFFECTED(victim, AFF_POISON))
      SET_BIT(victim->affected_by, AFF_POISON);
    if (!IS_AFFECTED(victim, AFF_FLAMING))
      SET_BIT(victim->affected_by, AFF_FLAMING);
    return;
}

void do_cyberform( CHAR_DATA *ch, char *argument )
{
  char buf [MAX_STRING_LENGTH];

  if (IS_NPC(ch)) return;

  if (!IS_CLASS(ch, CLASS_CYBORG) )
  {
    do_rand_typo(ch,"");
    return;
  }

  if (ch->pcdata->powers[CYBORG_BODY] < 5)
  {
    send_to_char("You must have level 5 body.\n\r",ch);
    return;
  }

  if ( IS_SET(ch->newbits, NEW_CUBEFORM))
  {
    REMOVE_BIT(ch->newbits, NEW_CUBEFORM);
    REMOVE_BIT(ch->affected_by, AFF_POLYMORPH);
    act( "A group of cyborgs come remove all of $n's cybernetic implants.",ch,NULL,NULL,TO_ROOM);
    send_to_char("You turn into your more human-like form.\n\r",ch);
    ch->damroll -= 350;
    ch->hitroll -= 350;
    free_string(ch->morph);
    ch->morph=str_dup("");
    WAIT_STATE(ch, 12);
    return;
  }
  else
  {
    act( "$n screams in agony as a group of cyborgs removes $s natural parts and implants artificial ones.",ch,ch,NULL,TO_ROOM);
    send_to_char("You allow a group of cyborgs to implant modifications to your body.\n\r",ch);
    SET_BIT(ch->newbits, NEW_CUBEFORM);
    SET_BIT(ch->affected_by, AFF_POLYMORPH);
    sprintf(buf,"%s a huge cybernetic being",ch->name);
    free_string(ch->morph);
    ch->morph = str_dup(buf);
    ch->damroll += 350;
    ch->hitroll += 350;
    WAIT_STATE(ch,12);
    return;
  }
  return;
}


void do_cybersight( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch)) return;

  if (!IS_CLASS(ch, CLASS_CYBORG))
  {
    do_rand_typo(ch,"");
    return;
  }

  if (ch->pcdata->powers[CYBORG_EYES] < 1)
  {
    send_to_char("You need at least 1 implant on your face to use your unholy sight.\n\r",ch);
    return;
  }
  if (ch->pcdata->powers[CYBORG_EYES] > 2)
  {
  if (IS_SET(ch->act, PLR_HOLYLIGHT))
  {
    REMOVE_BIT(ch->act, PLR_HOLYLIGHT);
    send_to_char("You turn off your unholy sight.\n\r",ch);
  }
  else
  {
    SET_BIT(ch->act, PLR_HOLYLIGHT);
    send_to_char("You turn on your unholy sight.\n\r",ch);
  }
  }
  else if (ch->pcdata->powers[CYBORG_EYES] == 2)
  {
    if (IS_SET(ch->affected_by, AFF_SHADOWSIGHT) && IS_SET(ch->pcdata->stats[UNI_AFF], VAM_NIGHTSIGHT))
    {
      REMOVE_BIT(ch->affected_by, AFF_SHADOWSIGHT);
      REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_NIGHTSIGHT);
      send_to_char("You turn off your unholy sight.\n\r",ch);
    }
    else
    {
      SET_BIT(ch->affected_by, AFF_SHADOWSIGHT);
      SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_NIGHTSIGHT);
      send_to_char("You turn on your unholy sight.\n\r",ch);
    }
  }
  else if ((ch->pcdata->powers[CYBORG_EYES] == 1))
  {
    if (IS_SET(ch->pcdata->stats[UNI_AFF], VAM_NIGHTSIGHT))
    {
      REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_NIGHTSIGHT);
      send_to_char("You turn off your unholy sight.\n\r",ch);
    }
    else
    {
      SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_NIGHTSIGHT);
      send_to_char("You turn on your unholy sight.\n\r",ch);
    }
  }
  return;
}

void do_cyborgarmor( CHAR_DATA *ch, char *argument )
{
    OBJ_INDEX_DATA *pObjIndex;
    OBJ_DATA *obj;
    char arg[MAX_INPUT_LENGTH];
    int vnum = 0;

    argument = one_argument( argument, arg );


    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_CYBORG))
    {
        do_rand_typo(ch,"");
	return;
    }
    
    if (arg[0] == '\0')
    {
    	send_to_char("Please specify which piece of drider armor you wish to make: whip ring
collar armor helmet leggings boots gloves sleeves cloak belt bracer mask.\n\r",ch);
    	return;
    }

    if (!str_cmp(arg,"whip"        )) vnum = 33140;
    else if (!str_cmp(arg,"ring"     )) vnum = 33141;
    else if (!str_cmp(arg,"collar"   )) vnum = 33142;
    else if (!str_cmp(arg,"armor"    )) vnum = 33143;
    else if (!str_cmp(arg,"helmet"   )) vnum = 33144;
    else if (!str_cmp(arg,"leggings" )) vnum = 33145;
    else if (!str_cmp(arg,"boots"    )) vnum = 33146;
    else if (!str_cmp(arg,"gloves"   )) vnum = 33147;
    else if (!str_cmp(arg,"sleeves"  )) vnum = 33148;
    else if (!str_cmp(arg,"cloak"   )) vnum = 33149;
    else if (!str_cmp(arg,"belt"     )) vnum = 33150;
    else if (!str_cmp(arg,"bracer"    )) vnum = 33151;
    else if (!str_cmp(arg,"mask"      )) vnum = 33152;
    else
    {
        do_cyborgarmor(ch,"");
	return;
    }
    if ( ch->practice < 150)
    {
     send_to_char("It costs 150 points of primal to create a piece of drider armour.\n\r",ch);
     return;
    }
    if ( vnum == 0 || (pObjIndex = get_obj_index( vnum )) == NULL)
    {
	send_to_char("Missing object, please inform an SG Admin.\n\r",ch);
	return;
    }
    ch->practice   -= 150;
    obj = create_object(pObjIndex, 50);
    obj->questowner = str_dup(ch->pcdata->switchname);
    obj_to_char(obj, ch);
    act("$p appears in your hands.",ch,obj,NULL,TO_CHAR);
    act("$p appears in $n's hands.",ch,obj,NULL,TO_ROOM);
    return;
}

void do_cyborgs( CHAR_DATA *ch, char *argument )
{
  char buf[MAX_STRING_LENGTH];
  CHAR_DATA *gch;

  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_CYBORG))
  {
    do_rand_typo(ch,"");
    return;
  }

  send_to_char("#7[#CName            #7] [#C  Hp   #7] [#C Mana  #7] [#C Move  #7] [#C Gen#7] [#CExperience#7] [#C   CPs    #7]#n\n\r",ch);
  for ( gch = char_list; gch != NULL; gch = gch->next)
  {
    if (IS_NPC(gch)) continue;
    if (!IS_CLASS(gch, CLASS_CYBORG)) continue;
    sprintf( buf,"#7[#C%-16s#7] [#C%-7d#7] [#C%-7d#7] [#C%-7d#7] [#C%-4d#7] [#C%-10d#7] [#C%-10d#7]#n\n\r",
    capitalize( gch->name ), gch->hit, gch->mana, gch->move, gch->generation, gch->exp, gch->pcdata->stats[CLASS_POINTS]);
    send_to_char( buf, ch);
  }
  return;
}

void do_cloaking( CHAR_DATA *ch, char *argument)
{
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_CYBORG))
  {
    do_rand_typo(ch,"");
    return;
  }
  if (ch->pcdata->powers[CYBORG_BODY] < 4)
  {
    send_to_char("You need 4 body implants first!\n\r",ch);
    return;
  }
  if ((ch->fight_timer > 0) && !IS_SET(ch->act, PLR_WIZINVIS))
  {
    send_to_char("Not with a fight timer!\n\r",ch);
    return;
  }
  if (IS_SET(ch->act, PLR_WIZINVIS))
  {
    REMOVE_BIT(ch->act, PLR_WIZINVIS);
    send_to_char("You drop your cloaking field.\n\r",ch);
    act("$n appears from thin air!",ch,NULL,NULL,TO_ROOM);
  }
  else
  {
    send_to_char("You activate your cloaking field.\n\r",ch);
    act("$n vanishes as $e activates a cloaking device.",ch,ch,NULL,TO_ROOM);
    SET_BIT(ch->act, PLR_WIZINVIS);
  }
  return;
}
