/***************************************************************************
 *  WotK public release                                                    *
 *  (c)2000 'Queen Serenity' and 'Tamas D'Varde (Ryan Pessa)'              *
 *  Be sure to read WotK.doc in the docs directory.                        *
 *  Have fun! :)                                                           *
 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h"   
#include "element.h"


void do_study( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char arg1[MAX_INPUT_LENGTH];
    char arg2[MAX_INPUT_LENGTH];
    int cost = 0;

    smash_tilde(argument);

    argument = one_argument( argument, arg1 );
    argument = one_argument( argument, arg2 );
    if (IS_NPC(ch)) return;
    if (!IS_CLASS(ch, CLASS_ELEMENT))
    {
        return;
    }

    if (arg1[0] == '\0')
    {
        stc("Syntax: study (fire/water/wind/earth/spirit) improve\n\r",ch);
        return;
    }
        if (!str_cmp(arg1,"water") && ch->power[EL_FIRE] < 7) 
        {
            stc("You are not master of fire yet.\n\r",ch);
            return;
        }
        if (!str_cmp(arg1,"wind") && ch->power[EL_WATER] < 8) 
        {
            stc("You are not a master of water yet.\n\r",ch);
            return;
        }
        if (!str_cmp(arg1,"earth") && ch->power[EL_WIND] < 7)
        {
            stc("You are not a master of wind yet.\n\r",ch);
            return;
        }
     if (!str_cmp(arg1,"spirit"))
	if ((ch->power[EL_MASTER] < 4))
        {
            stc("You must master the 4 basic elementals before going onto spirit.\n\r",ch);
            return;
        }
    if (str_cmp(arg2,"improve"))
    {
        if (!str_cmp(arg1,"fire"))
        {
            if (ch->power[EL_FIRE] <= 0)
            {stc("You have no powers yet.\n\r",ch);return;}
            if (ch->power[EL_FIRE] > 0)
            stc("#RFlame Rush - rush at opponent with both swords.\n\r",ch);
            if (ch->power[EL_FIRE] > 1)
            stc("#RFlame Assist - Extra attack per round.\n\r",ch);
            if (ch->power[EL_FIRE] > 2)
            stc("#RTrue Flameblade - Improve your flameblades.\n\r",ch);
            if (ch->power[EL_FIRE] > 3)
            stc("#RFire General - You are a higher rank and can induct flame warriors, increased damcap.\n\r",ch);
            if (ch->power[EL_FIRE] > 4)
            stc("#RFire Bless - An Elemental Bless.\n\r",ch);
            if (ch->power[EL_FIRE] > 5)
            stc("#RMeteor Summon - The Fire god hurls Meteors at your enemy.\n\r",ch);
            if (ch->power[EL_FIRE] > 6)
            stc("#RFire Transform - You transform into a fire elemental.\n\r",ch);
            return;
        }
        else if (!str_cmp(arg1,"water"))
        {
            if (ch->power[EL_WATER] <= 0 )
            {stc("You have no water powers.\n\r",ch);return;}
            if (ch->power[EL_WATER] > 0)
            stc("#LSneaky Water - Super invis.\n\r",ch);
            if (ch->power[EL_WATER] > 1)
            stc("#LWater Assist - extra attack per round.\n\r",ch);
            if (ch->power[EL_WATER] > 2)
            stc("#LBlade of Waterfalls - improve your RushDaggers.\n\r",ch);
            if (ch->power[EL_WATER] > 3)
            stc("#LWater Lord - Rank is upgraded, more damcap and can induct water warriors.\n\r",ch);
            if (ch->power[EL_WATER] > 4)
            stc("#LWave Bonds - entrap your enemy in water.\n\r",ch);
            if (ch->power[EL_WATER] > 5)
            stc("#LWarrior in the Waves - Surprise attack no matter what.\n\r",ch);
            if (ch->power[EL_WATER] > 6)
            stc("#LTsunami- The Water God summons a Tsunami to attack your foes.\n\r",ch);
            if (ch->power[EL_WATER] > 7)
            stc("#LWater Transform - Turn into a Water Elemental.\n\r",ch);
            return;
        }
        else if (!str_cmp(arg1,"wind"))
        {
            if (ch->power[EL_WIND] <= 0 )
            {stc("You have no wind powers.\n\r",ch);return;}
            if (ch->power[EL_WIND] > 0)
            stc("Air Shriek: a powerful curse from the wind god.\n\r",ch);
            if (ch->power[EL_WIND] > 1)
            stc("Wind Assist: A small blast of wind knocks the wind out of the enemy.\n\r",ch);
            if (ch->power[EL_WIND] > 2)
            stc("Wind Ruler: You are promoted to the Wind Ruler, extra damcap and can recruit wind warriors.\n\r",ch);
            if (ch->power[EL_WIND] > 3)
            stc("Wind Jump: A gust of wind brings you to your enemies.\n\r",ch);
            if (ch->power[EL_WIND] > 4)
            stc("Wind Crush: A Powerful Attack with your Wind Staves.\n\r",ch);
            if (ch->power[EL_WIND] > 5)
            stc("Wind God: The Wind God causes a tornadoe to strike your enemies.\n\r",ch);
            if (ch->power[EL_WIND] > 6)
            stc("Wind Transform: Transform into the Wind Elemental Ruler.\n\r",ch);
            return;
        }
        else if (!str_cmp(arg1,"earth"))
        {
            if (ch->power[EL_EARTH] <= 0)
            {stc("You have no earth powers.\n\r",ch);return;}
            if (ch->power[EL_EARTH] > 0)
            stc("Earth Reinforce: add extra powers to equipment.\n\r",ch);
            if (ch->power[EL_EARTH] > 1)
            stc("Earth Assist: You hurl boulders at your opponents.\n\r",ch);
            if (ch->power[EL_EARTH] > 2)
            stc("Earth Hammers: Improve your Earth Hammers Greatly.\n\r",ch);
            if (ch->power[EL_EARTH] > 3)
            stc("Earth Saint: Upgraded rank, extra damcap and can create earth minions.\n\r",ch);
            if (ch->power[EL_EARTH] > 4)
            stc("Earth Bless: Enchant your weapons with the power of earth.\n\r",ch);
            if (ch->power[EL_EARTH] > 5)
            stc("Earth Smash: Crush your opponent with both hammers at the same time.\n\r",ch);
            if (ch->power[EL_EARTH] > 6)
            stc("Avalanche: The Earth God causes an avalanche to destroy your opponent's armor.\n\r",ch);
            if (ch->power[EL_EARTH] > 7)
            stc("Earth Form: Transform into The Earth Saint.\n\r",ch);
            return;
        }
        else if(!str_cmp(arg1,"spirit"))
        {
            if (ch->power[EL_SPIRIT] <= 0)
            {stc("You have no Spirit Powers.\n\r",ch);return;}
            if (ch->power[EL_SPIRIT] > 0)
            stc("Spirit Absorb: Absorb your spirit weapons and your arms will shift between them in battle.\n\r",ch);
            if (ch->power[EL_SPIRIT] > 1)
            stc("Spirit Assist: All 4 elementals attack your enemy, and the spirit guardian heals you.\n\r",ch);
            if (ch->power[EL_SPIRIT] > 2)
            stc("True Spirit: Enchant your blasters.\n\r",ch);
            if (ch->power[EL_SPIRIT] > 3)
            stc("Spirit Guardian: Upgrade Your rank to Spirit Guardian.\n\r",ch);
            if (ch->power[EL_SPIRIT] > 4)
            stc("Spirit Kill: When you surprise attack, you do 2x your damcap.\n\r",ch);
            if (ch->power[EL_SPIRIT] > 5)
            stc("Spirit Sense: Ultimate Truesight, see everything.\n\r",ch);
            if (ch->power[EL_SPIRIT] > 6)
            stc("Elemental Blast: All of the elementals come to your aid and blast your opponent.\n\r",ch);
            if (ch->power[EL_SPIRIT] > 7)
            stc("Spirit Trueform: Transform into the Spirit Guardian!\n\r",ch);
            return;
        }
        else
        {
            sprintf(buf,"Fire: %d Water: %d Wind: %d Earth: %d Spirit: %d Power: %d\n\r",
            ch->power[EL_FIRE],ch->power[EL_WATER],ch->power[EL_WIND], 
            ch->power[EL_EARTH],ch->power[EL_SPIRIT],ch->power[EL_POWER]);
            stc(buf,ch);
            return;
        }
    }
    else if(!str_cmp(arg2,"improve"))
    {
        int sel;
        int max;
        if (!str_cmp(arg1,"fire")){sel = EL_FIRE;max=7;}
        else if(!str_cmp(arg1,"water")){sel=EL_WATER;max=8;}
        else if(!str_cmp(arg1,"wind")){sel=EL_WIND;max=7;}
        else if(!str_cmp(arg1,"earth")){sel=EL_EARTH;max=8;}
        else if(!str_cmp(arg1,"spirit")){sel=EL_SPIRIT;max=8;}
        else
        {
            stc("Syntax: study (fire/water/wind/earth/spirit) improve\n\r",ch);
            return;
        }
        
        if (ch->power[sel]+1>max){stc("You already have all of those powers.\n\r",ch);return;}

        if (ch->power[sel] == 0) cost = 20000;
        else if (ch->power[sel] == 1) cost = 30000;
        else if (ch->power[sel] == 2) cost = 50000;
        else if (ch->power[sel] == 3) cost = 70000;
        else if (ch->power[sel] == 4) cost = 100000;
        else if (ch->power[sel] == 5) cost = 150000;
        else cost = 250000;

        if ((ch->power[EL_MASTER] > 0)) cost *= (ch->power[EL_MASTER]+1);

        if ((ch->power[EL_POWER] < cost))
        {
            sprintf(buf,"You do not have the required %d elemental points.\n\r",cost);
            stc(buf,ch);
            return;
        }
       if ((ch->power[EL_ORIG] == 0))
        {
            if (!str_cmp(arg1,"fire")) ch->power[EL_ORIG] = 1;
            else if (!str_cmp(arg1,"water")) ch->power[EL_ORIG] = 2;
            else if (!str_cmp(arg1,"wind")) ch->power[EL_ORIG] = 3;
            else if (!str_cmp(arg1,"earth")) ch->power[EL_ORIG] = 4;
            else ch->power[EL_ORIG] = 0;
        }
//        ch->power[sel] += 1;
	ch->power[sel] += 1;
        ch->power[EL_POWER] -= cost;
        sprintf(buf,"You improve your %s power.\n\r",arg1);
        stc(buf,ch);
	if ((ch->power[sel] >= max)){ ch->power[EL_MASTER] += 1;
	sprintf(buf,"You master the %s.\n\r",arg1);
	stc(buf,ch);}
        if ((ch->power[sel] == 1))
        {
            if (!str_cmp(arg1,"fire")) SET_BIT(ch->special, SPC_FIRE);
            else if (!str_cmp(arg1,"water")) SET_BIT(ch->special,SPC_WATER);
            else if (!str_cmp(arg1,"wind")) SET_BIT(ch->special,SPC_AIR);
            else if (!str_cmp(arg1,"earth")) SET_BIT(ch->special,SPC_EARTH);
            else if (!str_cmp(arg1,"special"))SET_BIT(ch->special, SPC_SPIRIT);
        }
        return;
    }
    else
    {
        stc("Syntax: study (fire/water/wind/earth/spirit) improve\n\r",ch);
        return;
    }
}

        
void do_elementalform( CHAR_DATA *ch, char *argument )
{
	char arg[MAX_INPUT_LENGTH];
        char buf1[MAX_STRING_LENGTH];
	smash_tilde(argument);

	argument = one_argument( argument, arg);

	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch,CLASS_ELEMENT))
        {return;}
	
	if (IS_AFFECTED(ch, AFF_POLYMORPH))
	{
	stc("You return to normal form.\n\r",ch);
	REMOVE_BIT(ch->affected_by,AFF_POLYMORPH);
        clear_stats(ch);
        free_string( ch->morph );
        ch->morph = str_dup( "" );
	return;
	}	

	if (arg[0] == '\0')
	{
	stc("Syntax: elementalform (fire wind water earth spirit)\n\r",ch);
	return;
	}
	else if (!str_cmp(arg,"fire"))
	{
	if ((ch->power[EL_FIRE] < 7))
	{
        stc("You need to be maxed in the fire power to do that.\n\r",ch);
	return;
	}
	else
	{
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
	clear_stats(ch);
	ch->hitroll += 900;
	ch->damroll += 900;
	ch->armor -= 2500;
        sprintf(buf1, "%s the Huge fire elemental", ch->name);
	free_string(ch->morph);
        ch->morph = str_dup(buf1);
	SET_BIT(ch->affected_by,AFF_POLYMORPH);
	ch->power[9] = EL_FIRE;
	return;
	}
	}
        else if (!str_cmp(arg,"water"))
        {
        if ((ch->power[EL_WATER] < 8))
        {
        stc("You need to be maxxed in the water power to do that.\n\r",ch);
        return;
        }
        else
        {
          if (ch->stance[0] != -1) do_stance(ch,"");
          if (ch->mounted == IS_RIDING) do_dismount(ch,"");
          clear_stats(ch);
          ch->hitroll += 750;
          ch->damroll += 750;
          ch->armor -= 4000;
          sprintf(buf1, "%s the Large water elemental", ch->name);
          free_string(ch->morph);
          ch->morph = str_dup(buf1);
          SET_BIT(ch->affected_by,AFF_POLYMORPH);
          ch->power[9] = EL_WATER;
          return;
        }
        }
        else if (!str_cmp(arg,"wind"))
        {
        if ((ch->power[EL_WIND] < 7))
        {
        stc("You need to be maxxed in the wind power to do that.\n\r",ch);
        return;
        }
        else
        {
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        clear_stats(ch);
        ch->hitroll += 650;
        ch->damroll += 650;
        ch->armor -= 4500;
        sprintf(buf1, "%s the small wind elemental", ch->name);
	free_string(ch->morph);
        ch->morph = str_dup(buf1);
        SET_BIT(ch->affected_by,AFF_POLYMORPH);
        ch->power[9] = EL_WIND;
        return;
        }
        }
        else if (!str_cmp(arg,"earth"))
        {
        if ((ch->power[EL_EARTH] < 8))
        {
        stc("You need to be maxxed in the Earth power to do that.\n\r",ch);
        return;
        }
        else
        {
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        clear_stats(ch);
        ch->hitroll += 900;
        ch->damroll += 900;
	ch->armor -= 6000;
        sprintf(buf1, "%s the Enermous earth Saint", ch->name);
	free_string(ch->morph);
        ch->morph = str_dup(buf1);
        SET_BIT(ch->affected_by,AFF_POLYMORPH);
        ch->power[9] = EL_EARTH;
        return;
        }
        }
        else if (!str_cmp(arg,"spirit"))
        {
        if ((ch->power[EL_SPIRIT] < 8))
        {
        stc("You need to be maxxed in the spirit power to do that.\n\r",ch);
        return;
        }
        else
        {
	clear_stats(ch);
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        ch->hitroll += 1800;
        ch->damroll += 1800;
	ch->armor -= 9000;
        sprintf(buf1, "%s the Spirit God", ch->name);
	free_string(ch->morph);
        ch->morph = str_dup(buf1);
        SET_BIT(ch->affected_by,AFF_POLYMORPH);
        ch->power[9] = EL_SPIRIT;
        return;
        }
        }
	else
	{stc("Syntax: elementalform (fire/earth/wind/water/spirit)\n\r",ch);
	return;
	}
	return;
}
void do_elemweapon( CHAR_DATA *ch, char *argument )
{
    OBJ_INDEX_DATA *pObjIndex;
    OBJ_DATA *obj; 
    char arg[MAX_INPUT_LENGTH];
    int vnum = 0;
    argument = one_argument( argument, arg );
         
    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_ELEMENT))
	{stc("Huh?\n\r",ch);return;}

	if (arg[0] == '\0')
	{
	stc("syntax: elemweapon (flameblade/rushdagger/windstave/earthhammer/spiritblaster)\n\r",ch);
	stc("(Note: you must have at least 1 in a power to get the weapon.\n\r",ch);
	return;
	}
	else if(!str_cmp(arg,"flameblade"))
	{
	if ((ch->power[EL_FIRE] < 1))
	{
	stc("You need at least a little fire power before you can create flameblades.\n\r",ch);
	return;
	}
	else vnum = 30100;
	}
	else if(!str_cmp(arg,"rushdagger"))
	{
	if ((ch->power[EL_WATER] < 1))
	{
	stc("You need at least a little water power to make rushdaggers.\n\r",ch);
	return;
	}
	else vnum = 30101;
	}
	else if(!str_cmp(arg,"windstave"))
	{
	if ((ch->power[EL_WIND] < 1))
	{
	stc("You need at least a little wind power to make windstaves.\n\r",ch);
	return;
	}
	else vnum = 30102;
	}
	else if(!str_cmp(arg,"earthhammer"))
	{
	if ((ch->power[EL_EARTH] < 1))
	{
	stc("You need at least a little earth power to create earth hammers.\n\r",ch);
	return;
	}
	else vnum = 30103;
	}
	else if (!str_cmp(arg,"spiritblaster"))
	{
	if ((ch->power[EL_SPIRIT] < 1))
	{
	stc("You need at least 1 spirit power before you can make the blasters.\n\r",ch);
	return;
	}
	else vnum = 30112;
	}
	else
	{
        stc("syntax: elemweapon (flameblade/rushdagger/windstave/earthhammer/spiritblaster)\n\r",ch);
        stc("(Note: you must have at least 1 in a power to get the weapon.\n\r",ch);
        return;
        }

        if ((ch->power[EL_POWER] < 100000))
	{
        stc("You do not have the required 100000 elemental points.\n\r",ch);
	return;
	}

    if ( vnum == 0 || (pObjIndex = get_obj_index( vnum )) == NULL)
    {
        send_to_char("Missing object, please inform an imp.\n\r",ch);
        return;
    }
    ch->power[EL_POWER] -= 100000;
    obj = create_object(pObjIndex, 50);
    obj->questowner = str_dup(ch->name);
    obj->questmaker = str_dup(ch->name);
    obj->value[1] = 50;
    obj->value[2] = 100;
      
    SET_BIT(obj->quest, QUEST_RELIC);
    obj_to_char(obj, ch);
    act("$p appears in your hands in a great explosion.",ch,obj,NULL,TO_CHAR);
    act("$p appears in $n's hands in a great explosion.",ch,obj,NULL,TO_ROOM);
    return;
}

void do_sneakywater( CHAR_DATA *ch, char *argument )
{
    if (IS_NPC(ch)) return;
         
        if (!IS_CLASS(ch, CLASS_ELEMENT) )
        {
                send_to_char("Huh?\n\r", ch);
                return;
        }
        
        if (IS_CLASS(ch, CLASS_ELEMENT) && ch->power[EL_WATER] < 1 )
        {
          send_to_char("You need a little water power to be absorbed in water.\n\r", ch);
          return;
        }

    if ( IS_SET(ch->act, PLR_WIZINVIS) )
    {
        REMOVE_BIT(ch->act, PLR_WIZINVIS);
        act( "$n reforms from water.", ch, NULL, NULL, TO_ROOM );
        send_to_char( "You reform from water.\n\r", ch );
    }
    else
    {   
        act( "$n is absorbed into water.", ch, NULL, NULL, TO_ROOM );
        send_to_char( "You are absorbed into water.\n\r", ch );
        SET_BIT(ch->act, PLR_WIZINVIS);
    }
    return;
}

void do_spiritsense( CHAR_DATA *ch, char *argument )
{
    if (IS_NPC(ch)) return;
     
        if (!IS_CLASS(ch, CLASS_ELEMENT) )
        {  
                send_to_char("Huh?\n\r", ch);
                return;
        }
        
    if (IS_CLASS(ch, CLASS_ELEMENT) && ch->power[EL_SPIRIT] < 2)
        {
          send_to_char("You need 2 spirit powers to improve your senses.\n\r", ch);
          return;
        }

                
    if ( IS_SET(ch->act, PLR_HOLYLIGHT) )
    {
        REMOVE_BIT(ch->act, PLR_HOLYLIGHT);
        send_to_char( "You're senses return to normal.\n\r", ch );
    }
    else
    {
        SET_BIT(ch->act, PLR_HOLYLIGHT);
        send_to_char( "You're senses increase into incredible proportions.\n\r", ch );
    }
                
    return;
}

void do_elemenchant( CHAR_DATA *ch, char *argument)
{ 
    OBJ_DATA *obj;
    AFFECT_DATA *paf = NULL;
    char arg[MAX_INPUT_LENGTH];
    int num = 0;
    argument = one_argument(argument, arg);

    if (IS_NPC(ch)) return;
    
    if ( !IS_CLASS(ch, CLASS_ELEMENT))
    {
    return; 
    }
	if (ch->power[EL_FIRE] < 3 && ch->power[EL_EARTH] < 3)
          {
          stc("Nothing Happens.\n\r",ch);
	return;
	}
    if( !(obj = get_obj_carry(ch,arg)) )
        if( !(obj = get_obj_wear(ch,arg)) )
        {
            send_to_char("You don't have that.\n\r",ch);
            return;
        }
      if (!(!str_cmp(obj->questowner, ch->name) && !str_cmp(obj->questmaker, ch->name)))
      {
        send_to_char("The elementals only allow you to enchant your own weapons",ch);
        return;
      }

    if ( IS_SET( obj->quest, QUEST_ELEMENCHANTED) ||
          ( obj->pIndexData->vnum != 30100
         && obj->pIndexData->vnum != 30101
         && obj->pIndexData->vnum != 30102
         && obj->pIndexData->vnum != 30103
         && obj->pIndexData->vnum != 30112 ))
        {
          stc("That is not an elemental weapon!.\n\r",ch);
          return;
        }
     
    if (ch->power[EL_POWER] < 50000)
    {
        send_to_char("You must have 50000 elemental points to bless items.\n\r",ch);
        return;
    }
    
    ch->power[EL_POWER] -= 50000;
     
    if (ch->power[EL_MASTER] > 0)
    {
    if (ch->power[EL_FIRE] > 2)
    num = 50*ch->power[EL_MASTER];
    if ( affect_free == NULL )
    {
        paf             = alloc_perm( sizeof(*paf) );
    }
    else
    {
        paf             = affect_free;
        affect_free     = affect_free->next;
    }
    paf->type   = 0;
    paf->duration       = -1;
    paf->location       = APPLY_HITROLL;
    paf->modifier       = num;
    paf->bitvector      = 0;
    paf->next           = obj->affected;
    obj->affected       = paf;
    if ( affect_free == NULL )
    {
        paf             = alloc_perm( sizeof(*paf) );
    }
    else
    {
        paf             = affect_free;
        affect_free     = affect_free->next;
    }
    paf->type   = 0;
    paf->duration       = -1;
    paf->location       = APPLY_DAMROLL;
    paf->modifier       = num;
    paf->bitvector      = 0;
    paf->next           = obj->affected;
    obj->affected       = paf;

//    add_affect(obj,APPLY_HITROLL,number_fuzzy(num));
//    add_affect(obj,APPLY_DAMROLL,number_fuzzy(num));
    if (ch->power[EL_EARTH] > 2)
    num = 0;
    num -= number_fuzzy(500)*ch->power[EL_MASTER];
//    add_affect(obj,APPLY_AC,(-number_fuzzy(500)*ch->elem[EL_MASTER]));
    if ( affect_free == NULL )
    {
        paf             = alloc_perm( sizeof(*paf) );
    }
    else
    {
        paf             = affect_free;
        affect_free     = affect_free->next;
    }
    paf->type   = 0;
    paf->duration       = -1;
    paf->location       = APPLY_AC;
    paf->modifier       = num;
    paf->bitvector      = 0;
    paf->next           = obj->affected;
    obj->affected       = paf;

    }
    else
    {
    if (ch->power[EL_FIRE] > 2)
    if ( affect_free == NULL )
    {
        paf             = alloc_perm( sizeof(*paf) );
    }
    else
    {
        paf             = affect_free;
        affect_free     = affect_free->next;
    }
    paf->type   = 0;
    paf->duration       = -1;
    paf->location       = APPLY_HITROLL;
    paf->modifier       = number_fuzzy(50);
    paf->bitvector      = 0;
    paf->next           = obj->affected;
    obj->affected       = paf;
    if ( affect_free == NULL )
    {
        paf             = alloc_perm( sizeof(*paf) );
    }
    else
    {
        paf             = affect_free;
        affect_free     = affect_free->next;
    }
    paf->type   = 0;
    paf->duration       = -1;
    paf->location       = APPLY_DAMROLL;
    paf->modifier       = number_fuzzy(50);
    paf->bitvector      = 0;
    paf->next           = obj->affected;
    obj->affected       = paf;

//    add_affect(obj,APPLY_HITROLL,number_fuzzy(50));
//    add_affect(obj,APPLY_DAMROLL,number_fuzzy(50));
    if (ch->power[EL_EARTH] > 2)
    if ( affect_free == NULL )
    {
        paf             = alloc_perm( sizeof(*paf) );
    }
    else
    {
        paf             = affect_free;
        affect_free     = affect_free->next;
    }
    paf->type   = 0;
    paf->duration       = -1;
    paf->location       = APPLY_AC;
    paf->modifier       = number_fuzzy(500);
    paf->bitvector      = 0;
    paf->next           = obj->affected;
    obj->affected       = paf;

//    add_affect(obj,APPLY_AC,-number_fuzzy(500));
    }
    SET_BIT(obj->quest, QUEST_ELEMENCHANTED);
    act("$p radiates elemental power.",ch,obj,NULL,TO_CHAR);
    act("$p radiates with elemental power in $n's hands .",ch,obj,NULL,TO_ROOM);
        
    return;
   
}

